 
  'Problema PI-1B
 
  'Clculo de la funcin error con el mtodo propuesto por G. E. Forsythe
           
            'Versin 1.0 (creado por J. Antonio Ruiz G., 1993)
  
   DECLARE SUB asciival (X!)
   DECLARE SUB enrolla ()
   DECLARE SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
  
   'Se invoca la subrutina que despliega una cortina de presentacin
     CALL enrolla
  
   'Se designa el color del monitor
     COLOR 7, 9, 9
     CLS
 
   'Se invoca a la subrutina que genera un marco
     CALL marco(2, 4, 2, 79, 10, 7)
  
   'Letrero para salir o continuar
     COLOR 15
       LOCATE 3, 9: PRINT "CALCULO  DE  LA  FUNCION  ERROR  CON  EL  METODO  DE  FORSYTHE"
     COLOR 0, 7
       LOCATE 24, 25: PRINT " TECLEE < ESC > PARA TERMINAR "
     COLOR 7, 9
   
   LOCATE 9, 1

   'Inicio del programa
   DO
     CLEAR
    
     'Proteccin contra errores de overflow
       ON ERROR GOTO 10
    
     'Captura del argumento
       LOCATE 10, 30: PRINT "Valor X ";
       COLOR 23
         PRINT "? ";
       COLOR 7
    
     'Se invoca la subrutina que controla la captura
       CALL asciival(X)
    
     LOCATE 10, 40: PRINT "                   "
     
     'PI= 
       PI = 3.141592654#
    
     'Inicializando variables con el valor apropiado
       T = X
       S = X
       XSQ = X ^ 2
    
     'Principia ciclo iterativo (EN=0)
       DO
         OLDS = S
         EN = EN + 1!
         T = -XSQ * T * (2! * EN - 1!) / (EN * (2! * EN + 1!))
         S = S + T
       LOOP WHILE (OLDS <> S)
    
     'Se invoca a la subrutina que genera un marco
       CALL marco(14, 16, 16, 65, 12, 7)
      
     'Resutados
       AUXT = (2 / SQR(PI)) * S
       LOCATE 15, 20: PRINT "erf("; : PRINT USING "#.#"; X;
       PRINT ") = "; : PRINT USING "##.######## "; AUXT;
       IF X = 0 THEN EN = 0
       PRINT " en "; : PRINT USING "## "; EN; : PRINT " iteraciones"
  
   LOOP
  
   'Seccin de deteccin de errores
10   SOUND 300, 10
     CLS
     'Resultados hasta antes del error de overflow
       AUXT = (2 / SQR(PI)) * S
       LOCATE 15, 18: PRINT "erf("; : PRINT USING "#.#"; X;
       PRINT ") = "; AUXT;
       PRINT " en "; : PRINT USING "## "; EN; : PRINT " iteraciones"
     COLOR 31
       LOCATE 13, 30: PRINT "Error de overflow ..."
     COLOR 7
     RESUME 20
20   END

SUB asciival (X)

 'Subrutina para captura y discriminacin de caracteres numricos

1  'Captura del primer dgito
     DO
       k$ = INKEY$
     LOOP WHILE k$ = ""
 
   'Traslado a cdigo ASCII del primer dgito
     qy = ASC(RIGHT$(k$, 1))
 
   'Accin a seguir en funcin de la tecla oprimida
     SELECT CASE qy
            CASE 13  'Enter
               'Se asigna el valor de cero
                 entrada$ = CHR$(48)
                 X = VAL(entrada$)
          
            CASE 27  'escape
               'Salida
                 CLS
                 END
             
            CASE 45 TO 57  'Nmeros y signos
               'Traslado a cadena del primer dgito
                 entrada$ = CHR$(qy)
                 PRINT entrada$;
               'Captura de los dgitos subsecuentes
2                DO
                   ky$ = INKEY$
                 LOOP WHILE ky$ = ""
               'Traslado a cdigo ASCII
                 kz = ASC(RIGHT$(ky$, 1))
               'Accin a seguir en funcin de las teclas subsecuentes
                 SELECT CASE kz
                        CASE 8 'Correccin de caracteres
                           'Posicin del cursor rengln y columna
                             AA = CSRLIN
                             BB = POS(0)
                           'Cuando se llega a la posicin inicial se aborta
                             IF BB = 1 THEN
                                SOUND 3700, 4
                                GOTO 2
                             END IF
                           'El ltimo caracter se reemplaza por un espacio
                           'en blanco (posicin n)
                             LOCATE AA, BB - 1: PRINT " ";
                           'Reubicacin en la posicin n-1
                             LOCATE AA, BB - 1
                           'Longitud de la cadena con espacio en blanco
                             lng = LEN(entrada$)
                           'Nueva longitud de la cadena (n-1)
                             entrada$ = LEFT$(entrada$, lng - 1)
                           GOTO 2
                      
                        CASE 13  'Enter (cantidad deseada)
                           'Asignacin de valor a la variable X
                             X = VAL(entrada$)
                      
                        CASE 27  'escape
                           'Salida
                             CLS
                             END
                      
                        CASE 45 TO 57  'Se aceptan nmeros y signos, para
                                       'conformar una cifra
                           'Se constituye una cadena
                             entrada$ = entrada$ + CHR$(kz)
                             PRINT CHR$(kz);
                             GOTO 2
                      
                        CASE ELSE  'se rechazan otros cracteres
                           SOUND 420, 5
                           GOTO 2
                 END SELECT
          
            CASE ELSE  'Caracteres no vlidos
                SOUND 420, 5
                GOTO 1
     END SELECT

END SUB

SUB enrolla
 
  'Subrutina que despliega una cortina para presentacin de ttulos
  
   'Creacin de la cortina
     CLS
     VIEW PRINT
     COLOR 3, 1
       FOR AR = 8 TO 70
           FOR RA = 4 TO 21
               COLOR 7
                 LOCATE RA + 1, AR + 1: PRINT ""
               COLOR 3
                 LOCATE RA, AR: PRINT ""
       NEXT RA, AR
  
   'Letreros
     COLOR 0, 3
       LOCATE 7, 22: PRINT "T E C N I C A S    A V A N Z A D A S "
       LOCATE 9, 25: PRINT "D E    P R O G R A M A C I O N"
       LOCATE 13, 33: PRINT "EJEMPLO PI-1B"
       LOCATE 17, 25: PRINT "CALCULO DE LA FUNCION ERROR CON"
       LOCATE 18, 30: PRINT "EL METODO DE FORSYTHE"
     COLOR 31, 0
       LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
   
   'Pausa de 2.5 segundos
     SLEEP 2.5

END SUB

SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)

 'Subrutina que genera un marco

   'reni%, renf%-- rengln inicial y final del recuadro
   'coli%, colf%-- columna inicial y final del recuadro
   'ci%, cf%    -- color inicial (recuadro) y final (mensaje)

   'Caractersticas del marco (lnea sencilla)
     esi$ = "": lhs$ = "": lv$ = "": esd$ = ""
     eii$ = "": lhi$ = "": eid$ = ""

   'Se despliega el recuadro
     COLOR ci%
       LOCATE reni%, coli%: PRINT esi$
       LOCATE reni%, colf%: PRINT esd$
       LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
       FOR I% = reni% + 1 TO renf%
          LOCATE I%, coli%: PRINT lv$
          LOCATE I%, colf%: PRINT lv$
       NEXT I%
       LOCATE renf%, coli%: PRINT eii$
       LOCATE renf%, colf%: PRINT eid$
       LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
     COLOR cf%

END SUB

