  
   'Programa fuente de la Tcnica de Thomas para una matriz cuadrada
   'tridiagonal
                
               'Versin 1.0 (creado por J. Antonio Ruiz G., 1992)
   
    DECLARE SUB asciival (X!)
    DECLARE SUB borrado (coorx!, coory!, dato!)
    DECLARE SUB enrolla ()
    DECLARE SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
    DECLARE SUB matriz (xpos!, dato!, I!, J!, aux!, coorx1!)
    DECLARE SUB thomas (N, A(), F(), X())
  
   'Cursor invisible
   LOCATE , , 0

   'Se invoca a la subrutina que genera una pantalla de presentacin
    CALL enrolla

   'Inicia el proceso
    DO
      'Se designa el rea visual de trabajo y se le asigna color
       CLEAR
       VIEW PRINT
       COLOR 7, 9, 9
       CLS : BEEP
  
      'Proteccin contra errores de underflow u overflow
       ON ERROR GOTO 30
     
      'Se invoca a la subrutina que genera un marco
       CALL marco(1, 3, 1, 80, 13, 15)
       COLOR 0, 7
         LOCATE 24, 25: PRINT " TECLEE < ESC > PARA TERMINAR "
       COLOR 7, 9
     
      'Captura del orden N del sistema
       DO
          LOCATE 5, 19: PRINT "Orden (n) de la matriz (incgnitas) ? ";
          'Coordenadas del cursor
            coorx = CSRLIN: coory = POS(0)
          'Subrutina para captura
            CALL asciival(AUXN)
          'Cambio de variable, (AUXN es real y N es entera)
            N = AUXN
          IF N <= 0 THEN
             SOUND 200, 7
             'Subrutina para borrado de cadenas capturadas
               CALL borrado(coorx, coory, AUXN)
          END IF
       LOOP WHILE N <= 0
      
       LOCATE 5, 19: PRINT "                                           "
     
      'Dimensionando a la matriz de coeficientes A, al vector de trminos
      'independientes F y al vector solucin X
       DIM A(N, N), F(N), X(N)
  
      'Captura de datos
       FOR I = 1 TO N
            BEEP
           FOR J = 1 TO N
                LOCATE 5, 27: PRINT "Elemento   A("; I; ","; J; ") = ";
                'Coordenadas del cursor
                  coorx = CSRLIN: coory = POS(0)
                'Subrutina para captura
                  CALL asciival(dato)
                A(I, J) = dato
                'Subrutina para despliegue en forma de arreglo matricial
                  CALL matriz(7, dato, I, J, 0, coorx1)
                'Subrutina para borrado de cadenas capturadas
                  CALL borrado(coorx, coory, dato)
           NEXT J
           LOCATE 5, 27: PRINT "Trmino indep. F("; I; ") = ";
           'Coordenadas del cursor
             coorx = CSRLIN: coory = POS(0)
           'Subrutina para captura
             CALL asciival(dato)
           F(I) = dato
           CALL matriz(7, dato, I, J, 1, coorx1)
           'Subrutina para borrado de cadenas capturadas
             CALL borrado(coorx, coory, dato)
        NEXT I
   
        LOCATE 5, 27: PRINT "                             "
      
      'Invocando a la  subrutina de la Tcnica de Thomas
       CALL thomas(N, A(), F(), X())
  
      'Despliegue de resultados (vector x)
       SOUND 220, 6
       LOCATE coorx1 + 1, 27: PRINT "Solucin del sistema:"
       FOR I = 1 TO N
           LOCATE (coorx1 + 1) + I, 30: PRINT "X("; I; ") = "; : PRINT USING "######.##"; X(I)
       NEXT
    
     'Eleccin de proseguir o finalizar
10      LOCATE 24, 25: PRINT "  DESEA OTRO CALCULO (S/N) ?  ";
      'Coordenadas del cursor
        coorx = CSRLIN: coory = POS(0)
  
      'Captura
20      DO
          k$ = INKEY$
        LOOP WHILE k$ = ""
   
      'El cracter tecleado se transforma maysculas
        k$ = UCASE$(k$)
 
      'Se seleccion S o N?
        IF k$ = "N" THEN
           'Fin de sesin
             CLS : END
        ELSE
           IF k$ <> "S" THEN
              SOUND 500, 2
              'Borrado de un caracter sobre la lnea actual
                 LOCATE coorx, coory - 1: PRINT "   "
              GOTO 20
           END IF
        END IF
  
   LOOP
   
    'Sentencias para manejo de errores de underflow u overflow
30    BEEP: CLS
      LOCATE 14, 14
      PRINT "Error detectado: Sistema Incompatible (matriz singular)"
      RESUME 40
40    END

SUB asciival (X)

 'Subrutina para captura y discriminacin de caracteres numricos

1  'Captura del primer dgito
     DO
       k$ = INKEY$
     LOOP WHILE k$ = ""
 
   'Traslado a cdigo ASCII del primer dgito
     qy = ASC(RIGHT$(k$, 1))
 
   'Accin a seguir en funcin de la tecla oprimida
     SELECT CASE qy
            CASE 13  'Enter
               'Se asigna el valor de cero
                 entrada$ = CHR$(48)
                 X = VAL(entrada$)
          
            CASE 27  'escape
               'Salida
                 CLS
                 END
             
            CASE 45 TO 57  'Nmeros y signos
               'Traslado a cadena del primer dgito
                 entrada$ = CHR$(qy)
                 PRINT entrada$;
               'Captura de los dgitos subsecuentes
2                DO
                   ky$ = INKEY$
                 LOOP WHILE ky$ = ""
               'Traslado a cdigo ASCII
                 kz = ASC(RIGHT$(ky$, 1))
               'Accin a seguir en funcin de las teclas subsecuentes
                 SELECT CASE kz
                        CASE 8 'Correccin de caracteres
                           'Posicin del cursor rengln y columna
                             aa = CSRLIN
                             BB = POS(0)
                           'Cuando se llega a la posicin inicial se aborta
                             IF BB = 1 THEN
                                SOUND 3700, 4
                                GOTO 2
                             END IF
                           'El ltimo caracter se reemplaza por un espacio
                           'en blanco (posicin n)
                             LOCATE aa, BB - 1: PRINT " ";
                           'Reubicacin en la posicin n-1
                             LOCATE aa, BB - 1
                           'Longitud de la cadena con espacio en blanco
                             lng = LEN(entrada$)
                           'Nueva longitud de la cadena (n-1)
                             entrada$ = LEFT$(entrada$, lng - 1)
                           GOTO 2
                      
                        CASE 13  'Enter (cantidad deseada)
                           'Asignacin de valor a la variable X
                             X = VAL(entrada$)
                      
                        CASE 27  'escape
                           'Salida
                             CLS
                             END
                      
                        CASE 45 TO 57  'Se aceptan nmeros y signos, para
                                       'conformar una cifra
                           'Se constituye una cadena
                             entrada$ = entrada$ + CHR$(kz)
                             PRINT CHR$(kz);
                             GOTO 2
                      
                        CASE ELSE  'se rechazan otros cracteres
                           SOUND 420, 5
                           GOTO 2
                 END SELECT
          
            CASE ELSE  'Caracteres no vlidos
                SOUND 420, 5
                GOTO 1
     END SELECT

END SUB

SUB borrado (coorx, coory, dato)

'Subrutina para borrar caracteres tecleados
  
   'Conversin de valor numrico a cadena
   dato$ = STR$(dato)
   'Posicionamiento en la ltima coordenada del cursor
   LOCATE coorx, coory
   'Borrado de la longitud de la cadena (caracter por caracter)
   FOR s = 1 TO LEN(dato$)
           PRINT " ";
   NEXT

END SUB

SUB enrolla
 
  'Subrutina que despliega una cortina para presentacin de ttulos
 
   'Creacin de la cortina
     CLS
     VIEW PRINT
     COLOR 3, 1
       FOR AR = 8 TO 70
           FOR RA = 4 TO 21
               COLOR 7
                 LOCATE RA + 1, AR + 1: PRINT ""
               COLOR 3
                 LOCATE RA, AR: PRINT ""
       NEXT RA, AR
 
   'Letreros
     COLOR 0, 3
       LOCATE 7, 22: PRINT "T E C N I C A S    A V A N Z A D A S "
       LOCATE 9, 25: PRINT "D E    P R O G R A M A C I O N"
       LOCATE 13, 30: PRINT "C A P I T U L O   II"
       LOCATE 16, 24: PRINT "Tcnica de Thomas para una matriz"
       LOCATE 17, 31: PRINT "cuadrada tridiagonal"
       
     COLOR 31, 0
       LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
  
   'Pausa de 2.5 segundos
     SLEEP 2.5

END SUB

SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
 
 'Subrutina que genera un marco
 
   'reni%, renf%-- rengln inicial y final del recuadro
   'coli%, colf%-- columna inicial y final del recuadro
   'ci%, cf%    -- color inicial (recuadro) y final (mensaje)
 
   'Caractersticas del marco (lnea sencilla)
     esi$ = "": lhs$ = "": lv$ = "": esd$ = ""
     eii$ = "": lhi$ = "": eid$ = ""
 
   'Se despliega el recuadro
   COLOR ci%
     LOCATE reni%, coli%: PRINT esi$
     LOCATE reni%, colf%: PRINT esd$
     LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
     FOR I% = reni% + 1 TO renf%
         LOCATE I%, coli%: PRINT lv$
         LOCATE I%, colf%: PRINT lv$
     NEXT I%
     LOCATE renf%, coli%: PRINT eii$
     LOCATE renf%, colf%: PRINT eid$
     LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
   COLOR cf%

   'Letrero
     LOCATE 2, 5
     PRINT "ALGORITMO DE THOMAS PARA SISTEMAS CUADRADOS DE ECUACIONES TRI-DIAGONALES"

END SUB

SUB matriz (xpos, dato, I, J, aux, coorx1)

'Subrutina para formar un arreglo matricial
  'Encabezados
  IF I = 1 THEN
     LOCATE xpos, 10 * J
     IF aux = 1 THEN PRINT "T.I." ELSE PRINT "X("; J; ")"
  END IF
  'Elementos
  LOCATE xpos + I, 9 * J - 1: PRINT USING "#####.##"; dato
  'Posicin vertical del cursor
  coorx1 = CSRLIN

END SUB

SUB thomas (N, A(), F(), X())
 
  'Algoritmo de Thomas para una matriz cuadrada tridiagonal

    'Asignando los valores A(i,j) de las diagonales diferentes de cero
    'a los elementos involucrados en el algoritmo [AA(i), B(i), C(i)] y
    'dimensionando los arreglos involucrados
      DIM aa(N), b(N), c(N)
     
      FOR I = 2 TO N
          aa(I) = A(I, I - 1)
      NEXT
     
      FOR I = 1 TO N
          b(I) = A(I, I)
      NEXT
     
      FOR I = 1 TO N - 1
          c(I) = A(I, I + 1)
      NEXT
   
    'Eliminando de la RAM a la matriz A
      ERASE A
   
    'Clculo de las matrices L y U, as como dimensionamiento de arreglos
      DIM alfa(N), beta(N), Y(N)
     
      alfa(1) = b(1)
     
      FOR I = 1 TO N
          IF I > 1 THEN alfa(I) = b(I) - (aa(I) * beta(I - 1))
          IF I < N THEN beta(I) = c(I) / alfa(I)
      NEXT
   
    'Eliminando de la RAM a los vectores  B y C
      ERASE b, c
   
    'Sustitucin hacia adelante para obtener al vector Y, sabiendo que LY=F
      Y(1) = F(1) / alfa(1)
     
      FOR I = 2 TO N
          Y(I) = (F(I) - (aa(I) * Y(I - 1))) / alfa(I)
      NEXT
   
    'Sustitucin hacia atrs para obtener al vector X, sabiendo que UX=Y
      X(N) = Y(N)
     
      FOR I = N - 1 TO 1 STEP -1
          X(I) = Y(I) - (beta(I) * X(I + 1))
      NEXT
   
    'Eliminando de la RAM a los vectores  AA ,ALFA, BETA, Y y F
      ERASE aa, alfa, beta, F, Y

END SUB

