  
   'Intepolacin exacta mediante la subrutina SPLINE y la funcin SEVAL
      
      'Versin 1.0 (programa fuente creado por J. Antonio Ruiz G., 1992)
  
    DEFINT I-K, N
    DECLARE SUB asciival (X!)
    DECLARE SUB borrado (coorx!, coory!, dato!)
    DECLARE SUB centra (posx!, Title$)
    DECLARE SUB enrolla ()
    DECLARE SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
    DECLARE FUNCTION seval (N, U, X(), Y(), B(), C(), D(), OP)
    DECLARE SUB spline (N, X(), Y(), B(), C(), D())
  
    'Cursor invisible
     LOCATE , , 0

    'Se invoca a la subrutina que genera una pantalla de presentacin
     CALL enrolla

    'Inicia el proceso
    DO
      'Se designa el rea visual de trabajo y se le asigna color
        CLEAR
        VIEW PRINT
        COLOR 7, 9, 9
        CLS : BEEP
    
      'Invocando a la subrutina que genera un marco
        CALL marco(2, 4, 3, 78, 10, 15)
        COLOR 0, 7
          LOCATE 24, 25: PRINT " TECLEE < ESC > PARA TERMINAR "
        COLOR 7, 9
     
      'Captura del nmero de pares de puntos
       DO
          LOCATE 6, 25: PRINT "Nm. de pares de datos ? ";
          'Coordenadas del cursor
            coorx = CSRLIN: coory = POS(0)
          'Subrutina para captura
            CALL asciival(AUXN)
          'Cambio de variable, (AUXN es real y N es entera)
            N = AUXN
          IF N <= 0 THEN
             SOUND 200, 7
             'Subrutina para borrado de cadenas capturadas
               CALL borrado(coorx, coory, AUXN)
          END IF
       LOOP WHILE N <= 0
     
      'Dimensionando los vectores y matrices involucrados
        DIM X(N), Y(N), B(N), C(N), D(N)
    
      'Captura de pares de puntos
        'Nota: X=abscisas en estricto orden ascendente, Y=ordenadas
        LOCATE 8, 10: PRINT "Parejas de Datos :"
       
        FOR I = 1 TO N
            LOCATE 8 + I, 20: PRINT "X ("; I; ") =";
            'Subrutina para captura
             CALL asciival(dato)
            'Cambio de variable
             X(I) = dato
            'Se verifica el orden creciente de las abscisas
             IF X(I) < 0 THEN
                'Anomala en abscisas negativas
                IF ABS(X(I - 1)) > ABS(X(I)) THEN GOTO 30
             ELSE
                'Anomala en abscisas positivas
                IF X(I) < X(I - 1) THEN GOTO 30
             END IF
           
            LOCATE 8 + I, 45: PRINT "Y ("; I; ") =";
            'Subrutina para captura
             CALL asciival(dato)
            'Cambio de variable
             Y(I) = dato
       
        NEXT
    
      'Captura de valores por interpolar
      'U(AA)= vector de valores de la abscisa que se desea interpoLar
        posx = CSRLIN + 2
        DO
          LOCATE posx, 10: PRINT "Cuntos valores desea interpolar ? ";
          'Coordenadas del cursor
           coorx = CSRLIN: coory = POS(0)
          'Subrutina para captura
           CALL asciival(aa)
          IF aa <= 0 THEN
             SOUND 200, 7
             'Subrutina para borrado de cadenas capturadas
              CALL borrado(coorx, coory, aa)
          END IF
        LOOP WHILE aa <= 0
       
        'Dimensionando el vector de abscisas a interpoLar
         DIM U(aa)
       
        posx = CSRLIN
        FOR KK = 1 TO aa
            LOCATE posx + KK, 15: PRINT "Valor X("; KK; ") a interpolar = ";
            'Subrutina para captura
             CALL asciival(dato)
            'Cambio de variable
             U(KK) = dato
        NEXT
     
      COLOR 31
        LOCATE 24, 20: PRINT "Presione cualquier tecla para continuar ..."
      COLOR 7
        DO
        LOOP WHILE INKEY$ = ""
      
      CLS
    
      'Invocando a la subrutina que genera un marco
        CALL marco(2, 4, 3, 78, 10, 15)
        COLOR 7
     
      'Llamada a SPLINE
        CALL spline(N, X(), Y(), B(), C(), D())
    
      'Resultados
        LOCATE 9, 30: PRINT "Xinterp      Yinterp"
        LOCATE 10, 25: PRINT STRING$(30, "-")
       
        '***  Bsqueda secuencial si OP=1, binaria en cualquier otro caso  ***
          OP = 0
     
        'Se invoca a la funcin SEVAL tantas veces como abscisas por
        'interpolar se tengan
          FOR KK = 1 TO aa
              U = U(KK)
              'Funcin SEVAL, s= es el valor interpolado de la ordenada
               S = seval(N, U, X(), Y(), B(), C(), D(), OP)
              LOCATE 10 + KK, 26
              PRINT USING "#####.####    ####.####"; U; S
          NEXT
    
       'Eleccin de proseguir o finalizar
10       LOCATE 24, 25: PRINT "  DESEA OTRO CALCULO (S/N) ?  ";
       'Coordenadas del cursor
         coorx = CSRLIN: coory = POS(0)
 
       'Captura
20       DO
           k$ = INKEY$
         LOOP WHILE k$ = ""
  
       'El cracter tecleado se transforma maysculas
         k$ = UCASE$(k$)

       'Se seleccion S o N?
         IF k$ = "N" THEN
            'Fin de sesin
             CLS : END
         ELSE
            IF k$ <> "S" THEN
              SOUND 500, 2
              'Borrado de un caracter sobre la lnea actual
                 LOCATE coorx, coory - 1: PRINT "   "
              GOTO 20
           END IF
         END IF
 
   LOOP
  
   'Anomala en el orden creciente de las abscisas
30 SOUND 200, 10
   COLOR 31
     LOCATE 23, 25: PRINT "Abscisas en orden creciente !!"
   COLOR 7
   GOTO 10

SUB asciival (X)

 'Subrutina para captura y discriminacin de caracteres numricos

1  'Captura del primer dgito
     DO
       k$ = INKEY$
     LOOP WHILE k$ = ""
 
   'Traslado a cdigo ASCII del primer dgito
     qy = ASC(RIGHT$(k$, 1))
 
   'Accin a seguir en funcin de la tecla oprimida
     SELECT CASE qy
            CASE 13  'Enter
               'Se asigna el valor de cero
                 entrada$ = CHR$(48)
                 X = VAL(entrada$)
          
            CASE 27  'escape
               'Salida
                 CLS
                 END
             
            CASE 45 TO 57  'Nmeros y signos
               'Traslado a cadena del primer dgito
                 entrada$ = CHR$(qy)
                 PRINT entrada$;
               'Captura de los dgitos subsecuentes
2                DO
                   ky$ = INKEY$
                 LOOP WHILE ky$ = ""
               'Traslado a cdigo ASCII
                 kz = ASC(RIGHT$(ky$, 1))
               'Accin a seguir en funcin de las teclas subsecuentes
                 SELECT CASE kz
                        CASE 8 'Correccin de caracteres
                           'Posicin del cursor rengln y columna
                             aa = CSRLIN
                             BB = POS(0)
                           'Cuando se llega a la posicin inicial se aborta
                             IF BB = 1 THEN
                                SOUND 3700, 4
                                GOTO 2
                             END IF
                           'El ltimo caracter se reemplaza por un espacio
                           'en blanco (posicin n)
                             LOCATE aa, BB - 1: PRINT " ";
                           'Reubicacin en la posicin n-1
                             LOCATE aa, BB - 1
                           'Longitud de la cadena con espacio en blanco
                             lng = LEN(entrada$)
                           'Nueva longitud de la cadena (n-1)
                             entrada$ = LEFT$(entrada$, lng - 1)
                           GOTO 2
                      
                        CASE 13  'Enter (cantidad deseada)
                           'Asignacin de valor a la variable X
                             X = VAL(entrada$)
                      
                        CASE 27  'escape
                           'Salida
                             CLS
                             END
                      
                        CASE 45 TO 57  'Se aceptan nmeros y signos, para
                                       'conformar una cifra
                           'Se constituye una cadena
                             entrada$ = entrada$ + CHR$(kz)
                             PRINT CHR$(kz);
                             GOTO 2
                      
                        CASE ELSE  'se rechazan otros cracteres
                           SOUND 420, 5
                           GOTO 2
                 END SELECT
          
            CASE ELSE  'Caracteres no vlidos
                SOUND 420, 5
                GOTO 1
     END SELECT

END SUB

SUB borrado (coorx, coory, dato)

'Subrutina para borrar caracteres tecleados
  
   'Conversin de valor numrico a cadena
   dato$ = STR$(dato)
   'Posicionamiento en la ltima coordenada del cursor
   LOCATE coorx, coory
   'Borrado de la longitud de la cadena (caracter por caracter)
   FOR S = 1 TO LEN(dato$)
           PRINT " ";
   NEXT

END SUB

SUB centra (posx, Title$)
 
  'Subrutina para centrar textos con respecto a la pantalla
     'Coordenada "y" en base a la long. del texto y a la disponible en pantalla
     posy = INT((80 - LEN(Title$)) / 2)
     LOCATE posx, posy: PRINT Title$

END SUB

SUB enrolla
 
  'Subrutina que despliega una cortina para presentacin de ttulos
 
   'Creacin de la cortina
     CLS
     VIEW PRINT
     COLOR 3, 1
       FOR AR = 8 TO 70
           FOR RA = 4 TO 21
               COLOR 7
                 LOCATE RA + 1, AR + 1: PRINT ""
               COLOR 3
                 LOCATE RA, AR: PRINT ""
       NEXT RA, AR
 
   'Letreros
     COLOR 0, 3
       'Se invoca a la subrutina para centrado de textos
       CALL centra(7, "T E C N I C A S    A V A N Z A D A S ")
       CALL centra(9, "D E     P R O G R A M A C I O N")
       CALL centra(13, "C A P I T U L O   III")
       CALL centra(17, "Intepolacin exacta mediante la")
       CALL centra(18, "subrutina SPLINE y la funcin SEVAL")
       
     COLOR 31, 0
       LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
  
   'Pausa de 2.5 segundos
     SLEEP 2.5

END SUB

DEFSNG I-K, N
SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)

 'Subrutina que genera un marco

   'reni%, renf%-- rengln inicial y final del recuadro
   'coli%, colf%-- columna inicial y final del recuadro
   'ci%, cf%    -- color inicial (recuadro) y final (mensaje)

   'Caractersticas del marco (lnea sencilla)
     esi$ = "": lhs$ = "": lv$ = "": esd$ = ""
     eii$ = "": lhi$ = "": eid$ = ""

   'Se despliega el recuadro
   COLOR ci%
     LOCATE reni%, coli%: PRINT esi$
     LOCATE reni%, colf%: PRINT esd$
     LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
     FOR I% = reni% + 1 TO renf%
         LOCATE I%, coli%: PRINT lv$
         LOCATE I%, colf%: PRINT lv$
     NEXT I%
     LOCATE renf%, coli%: PRINT eii$
     LOCATE renf%, colf%: PRINT eid$
     LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
   COLOR cf%
  
   'Mensaje
     LOCATE 3, 5
     PRINT "INTERPOLACION SECUENCIAL O BINARIA USANDO LAS SUBRUTINAS  SPLINE Y SEVAL"

END SUB

DEFINT I-K, N
FUNCTION seval (N, U, X(), Y(), B(), C(), D(), OP)
  
   'Esta subrutina evala la funcin cbica spline:
  
        'seval = Y(I) + B(I)*(U-X(I)) + C(I)*(U-X(I))^2 + D(I)*(U-X(I))^3
  
   'donde:  X(I) < U < X(I+1), usando la regla de Horner.
  
   'Si U < X(1) entoces se supone que I=1.
   'Si U > X(N) entoces se supone que I=N.
  
   'Datos de entrada:
          'N = Nmero de datos.
          'U = Abscisa en la que se valuar el spline.
       'X, Y = Vectores de abscisas y ordenadas dato.
    'B, C, D = Vectores de coeficientes clculados por SPLINE.
         'OP = Variable que rige el tipo de bsqueda, secuencial si OP=1
              'y binaria en cualquier otro caso.
  
   'Si U no se ubica en el intervalo de la llamada previa, entonces  una
   'bsqueda binaria o secuencial ser ejecutada, para determinar el in-
   'tervalo apropiado.
   
   I = 1
   IF I >= N THEN I = 1
  
   'Se designa el mtodo de bsqueda
     SELECT CASE OP
           
            CASE 1
                 IF U <= X(I + 1) THEN GOTO se10
                 'Bsqueda secuencial para U < X(I)
                   k = 0
                   DO
                     k = k + 1
                     IF U < X(k) THEN J = k
                     IF U >= X(k) THEN I = k
                   LOOP WHILE k < N
           
            CASE ELSE
                 IF U <= X(I + 1) THEN GOTO se10
                 'Bsqueda binaria para U < X(I)
                   I = 1
                   J = N + 1
                   DO
                     k = INT((I + J) / 2)
                     IF U < X(k) THEN J = k
                     IF U >= X(k) THEN I = k
                   LOOP WHILE J > I + 1
    
     END SELECT
  
   'Se evala el spline
se10: DX = U - X(I)
      seval = Y(I) + DX * (B(I) + DX * (C(I) + DX * D(I)))

END FUNCTION

DEFSNG J
SUB spline (N, X(), Y(), B(), C(), D())
  
   'Los coeficientes B(I), C(I) y D(I), I=1,2,...,N, son calculados para
   'formar el polinomio de Splines cbicos:
  
       'S(X) = Y(I) + B(I)*(X-X(I)) + C(I)*(X-X(I))^2 + D(I)*(X-X(I))^3
  
   'para: X(I) =< X =< X(I+1).
  
   'Datos de entrada:
     'N = Nmero de datos, puntos o coordenadas (N >= 2).
     'X = Abscisa de las coordenadas dato en estricto orden  ascendente.
     'Y = Ordenada de las coordenadas dato.
  
   'Datos de salida:
     'B, C, D = vectores con coeficientes de SPLINE, indicados anterior-
               'mente.
  
   'Usando la letra "P" para denotar diferenciales:
     'Y(I) = S(X(I))
     'B(I) = SP(X(I))
     'C(I) = SPP(X(I))/2
     'D(I) = SPPP(X(I))/6
  
   'Nota: La funcin SEVAL evala el spline.
  
     NM1 = N - 1
     IF N < 2 THEN
        SOUND 200, 4: CLS
        COLOR 31
          LOCATE 12, 22: PRINT "EL No. DE DATOS DEBE SER MAYOR DE 2 !!"
        COLOR 7
        END
     END IF
     IF N < 3 THEN
        B(1) = (Y(2) - Y(1)) / (X(2) - X(1))
        C(1) = 0!
        D(1) = 0!
        B(2) = B(1)
        C(2) = 0!
        D(2) = 0!
        EXIT SUB
     END IF
  
   'Se crea un sistema tri-diagonal
   'B=diagonal principal, D=diagonal inmediata-superior, C=vector de trmi-
     'nos independientes
     D(1) = X(2) - X(1)
     C(2) = (Y(2) - Y(1)) / D(1)
     FOR I = 2 TO NM1
         D(I) = X(I + 1) - X(I)
         B(I) = 2! * (D(I - 1) + D(I))
         C(I + 1) = (Y(I + 1) - Y(I)) / D(I)
         C(I) = C(I + 1) - C(I)
     NEXT I
  
   'Condiciones finales. La tercera derivada de X(1) y X(N)  resultan  del
   'cociente de las diferencias
     B(1) = -D(1)
     B(N) = -D(N - 1)
     C(1) = 0!
     C(N) = 0!
     IF N = 3 THEN GOTO sp10
     C(1) = C(3) / (X(4) - X(2)) - C(2) / (X(3) - X(1))
     C(N) = C(N - 1) / (X(N) - X(N - 2)) - C(N - 2) / (X(N - 1) - X(N - 3))
     C(1) = C(1) * D(1) ^ 2 / (X(4) - X(1))
     C(N) = -C(N) * D(N - 1) ^ 2 / (X(N) - X(N - 3))
  
   'Sustitucin hacia adelante
sp10: FOR I = 2 TO N
          T = D(I - 1) / B(I - 1)
          B(I) = B(I) - T * D(I - 1)
          C(I) = C(I) - T * C(I - 1)
      NEXT I
  
   'Sustitucin hacia atrs
     C(N) = C(N) / B(N)
     FOR IB = 1 TO NM1
         I = N - IB
         C(I) = (C(I) - D(I) * C(I + 1)) / B(I)
     NEXT IB
  
   'Clculo de los coeficientes del polinomio
     B(N) = (Y(N) - Y(NM1)) / D(NM1) + D(NM1) * (C(NM1) + 2! * C(N))
     FOR I = 1 TO NM1
         B(I) = (Y(I + 1) - Y(I)) / D(I) - D(I) * (C(I + 1) + 2! * C(I))
         D(I) = (C(I + 1) - C(I)) / D(I)
         C(I) = 3! * C(I)
     NEXT I
     C(N) = 3! * C(N)
     D(N) = D(N - 1)

END SUB

