  
   'Problema PI-4
                            'Versin 1.0 (1993)
  
   DECLARE SUB enrolla ()
   DECLARE SUB fin ()
   DECLARE SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
  
   'Se invoca la subrutina que despliega una cortina de presentacin
     CALL enrolla
  
   'Se designa el color del monitor
     COLOR 7, 9, 9
     CLS
  
   'Letrero para salir o continuar
     COLOR 15
       LOCATE 3, 19: PRINT "E J E M P L O    R E S U E L T O    P I . 4"
     COLOR 0, 7
       LOCATE 24, 27: PRINT " TECLEE < ESC > PARA TERMINAR "
     COLOR 7, 9
  
   'Se invoca a la subrutina que genera un marco
     CALL marco(2, 4, 2, 79, 10, 7)
     CALL marco(10, 19, 11, 71, 12, 7)
   
   'Clculos
   
    'Variables de simple precisin
      H = 1! / 2!
      X = (2! / 3!) - H
      Y = (3! / 5!) - H
      E = (X + X + X) - H
      F = (Y + Y + Y + Y + Y) - H
      Q = F / E
   
    'Variables de doble precisin
      H# = 1! / 2!
      X# = (2! / 3!) - H#
      Y# = (3! / 5!) - H#
      E# = (X# + X# + X#) - H#
      F# = (Y# + Y# + Y# + Y# + Y#) - H#
      Q# = F# / E#
   
    'Resultados
      COLOR 15
        LOCATE 11, 20: PRINT "VARIABLE             PRECISION"
        LOCATE 12, 20: PRINT "               SIMPLE         DOBLE"
      COLOR 7
      LOCATE 13, 23: PRINT "H": LOCATE 13, 33: PRINT H: LOCATE 13, 48: PRINT H#
      LOCATE 14, 23: PRINT "X": LOCATE 14, 33: PRINT X: LOCATE 14, 48: PRINT X#
      LOCATE 15, 23: PRINT "Y": LOCATE 15, 33: PRINT Y: LOCATE 15, 48: PRINT Y#
      LOCATE 16, 23: PRINT "E": LOCATE 16, 33: PRINT E: LOCATE 16, 48: PRINT E#
      LOCATE 17, 23: PRINT "F": LOCATE 17, 33: PRINT F: LOCATE 17, 48: PRINT F#
      LOCATE 18, 23: PRINT "Q": LOCATE 18, 33: PRINT Q: LOCATE 18, 48: PRINT Q#

    'Se invoca a la subrutina que controla el fin de sesin
      CALL fin

SUB enrolla
 
  'Subrutina que despliega una cortina para presentacin de ttulos
  
   'Creacin de la cortina
     CLS
     VIEW PRINT
     COLOR 3, 1
       FOR AR = 8 TO 70
           FOR RA = 4 TO 21
               COLOR 7
                 LOCATE RA + 1, AR + 1: PRINT ""
               COLOR 3
                 LOCATE RA, AR: PRINT ""
       NEXT RA, AR
  
   'Letreros
     COLOR 0, 3
       LOCATE 7, 22: PRINT "T E C N I C A S    A V A N Z A D A S "
       LOCATE 9, 25: PRINT "D E    P R O G R A M A C I O N"
       LOCATE 14, 34: PRINT "EJEMPLO PI-4"
       LOCATE 18, 25: PRINT "EJEMPLO RESUELTO DEL CAPITULO I"
     COLOR 31, 0
       LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
   
   'Pausa de 2.5 segundos
     SLEEP 2.5

END SUB

SUB fin
 
  'Subrutina que contrla el fin de sesin
  
   'Ciclo iterativo para mostrar los resultados o salir de sesin
     DO
       'Captura
         DO
           k$ = INKEY$
         LOOP WHILE k$ = ""
     
       'Traslado a cdigo ASCII del primer dgito
         qy = ASC(RIGHT$(k$, 1))
       
       'Se seleccion ESCAPE?
         IF qy = 27 THEN
            EXIT DO
         ELSE
            SOUND 500, 2
         END IF
     LOOP
   
   CLS
   END

END SUB

SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)

 'Subrutina que genera un marco

   'reni%, renf%-- rengln inicial y final del recuadro
   'coli%, colf%-- columna inicial y final del recuadro
   'ci%, cf%    -- color inicial (recuadro) y final (mensaje)

   'Caractersticas del marco (lnea sencilla)
     esi$ = "": lhs$ = "": lv$ = "": esd$ = ""
     eii$ = "": lhi$ = "": eid$ = ""

   'Se despliega el recuadro
     COLOR ci%
       LOCATE reni%, coli%: PRINT esi$
       LOCATE reni%, colf%: PRINT esd$
       LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
       FOR I% = reni% + 1 TO renf%
          LOCATE I%, coli%: PRINT lv$
          LOCATE I%, colf%: PRINT lv$
       NEXT I%
       LOCATE renf%, coli%: PRINT eii$
       LOCATE renf%, colf%: PRINT eid$
       LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
     COLOR cf%

END SUB

