 
  'Programa de Anlisis de Regresin Mltiple y Graficacin
  '(Creado por Ing. Nstor Martnez y modificado por J. Antonio Ruiz/alumnos varios)
  'Versin 1.0 (1993)
 
  DECLARE SUB ayuda (tipo$)
  DECLARE SUB barra ()
  DECLARE SUB editor (FILE$, NEWFILE%, X#(), Y#(), ROWX%, ROW%, COLUMNX%)
  DECLARE SUB enrolla ()
  DECLARE SUB graf (FILESTK$(), CURVE$(), NOF%, TITLE$())
  DECLARE SUB head ()
  DECLARE SUB letgraf (XMIN!, XMAX!, YMIN!, YMAX!, TITLE$())
  DECLARE SUB letreros (tipo$, X%)
  DECLARE SUB marco (reni%, renf%, coli%, colf%, tipo%, ci%, cf%)
  DECLARE SUB menupantalla (FILE$, C1%, COLUMNX%, STATUS$())
  DECLARE SUB opcion1 (DN$, UP$, C1%, TIND%)
  DECLARE SUB opcion23 (FLAG1%, FILE$, NEWFILE%, X#(), Y#(), ROWX%, ROW%, COLUMNX%)
  DECLARE SUB opcion4 (FILE$, DN$, UP$, X#(), COLUMNX%, ROW%, P$(), STATUS$(), MX%, MY%)
 
  'Proteccin contra errores durante la ejecucin del programa
    ON ERROR GOTO PROCERROR
 
  'Se redefine la visibilidad cursor
    LOCATE , , 0
 
  'Subrutina de pantalla inicial
    CALL enrolla

  'Definicin de arreglos matriciales e inicializacin de variables
    DIM X#(200, 10), Y#(200), XX#(10, 10), INV#(10, 10), XY#(10), YHAT#(200)
    DIM B#(10), K(6), P$(10), STATUS$(10), CURVE$(4), FILESTK$(4), TITLE$(3)
    DONE% = 0: C1% = 95: TIND% = 4:  MX% = 5: MY% = 59: DX% = 0
    DN$ = CHR$(0) + CHR$(80): UP$ = CHR$(0) + CHR$(72): FILE$ = ""
 
  'Definicin del rea de despliegue en pantalla
INI:  CLS : SCREEN 0, 1: COLOR 15, 1: VIEW PRINT 1 TO 25
	 LOCATE 1, 1, 0: PRINT STRING$(2000, 32);
	 IF STATUS$(1) = "" THEN
		FOR I = 1 TO COLUMNX% - 1
		    I$ = CHR$(I + 48): STATUS$(I) = "C" + I$ + "= X" + I$
		NEXT
	 END IF
	 
 'Subrutina del men de pantalla
  CALL menupantalla(FILE$, C1%, COLUMNX%, STATUS$())

 'Desplazamiento del cursor
  DX% = 0
  X% = DX% + 6: LOCATE X%, 15, 1, 0, 7
MENU: ANS$ = INKEY$: IF ANS$ = "" THEN GOTO MENU
  IF ANS$ = CHR$(0) + CHR$(59) THEN CALL ayuda("MENU"): GOTO INI
  IF ANS$ = DN$ THEN IF X% < 13 THEN X% = X% + 1 ELSE X% = 6
  IF ANS$ = UP$ THEN IF X% > 6 THEN X% = X% - 1 ELSE X% = 13

 'Se invoca la subrutina de lectura de letreros para la barra de ayuda
  CALL letreros("MENU", X%)

 'Se oprime <enter>
  LOCATE X%, 15: IF ANS$ <> CHR$(13) THEN GOTO MENU
 
 'Eleccin
  FLAG1% = CSRLIN - 5

 SELECT CASE FLAG1%
   CASE 1: CALL opcion1(DN$, UP$, C1%, TIND%)
   CASE 2 TO 3:
   IF FLAG1% = 2 THEN LOCATE 23, 11, 0: COLOR 15, 1: PRINT STRING$(80, 32)
			 CALL opcion23(FLAG1%, FILE$, NEWFILE%, X#(), Y#(), ROWX%, ROW%, COLUMNX%)
   CASE 4: CALL opcion4(FILE$, DN$, UP$, X#(), COLUMNX%, ROW%, P$(), STATUS$(), MX%, MY%)
   CASE 5: GOSUB REGR
   CASE 6: GOSUB 2610
   CASE 7: GOSUB 2640
   CASE 8: CLS
		 'Se redefine la visibilidad y el tamao del cursor
		 LOCATE , , 0, 5, 6
		 END
 END SELECT

 GOTO INI

'------------------------------------------------------  LEE ARCH. DATOS
LEE:  Nf = FREEFILE: OPEN FILE$ FOR INPUT AS #Nf
				 INPUT #Nf, ROWX%, ROW%, COLUMNX%
				 FOR I = 1 TO ROWX%
					INPUT #Nf, Y#(I)
				 NEXT
				 FOR J = 2 TO COLUMNX%
					FOR I = 1 TO ROW%
					    INPUT #Nf, X#(I, J)
				 NEXT I, J
				 CLOSE #Nf
				 FOR I = 1 TO ROW%
					X#(I, 1) = 1!
				 NEXT
				 RETURN

'---------------------------------------------------  SEL. DE REGRESORES
2610 : IF DONE% = 1 THEN GOSUB 2800 ELSE GOSUB REGR
		RETURN
2640 : IF FILE$ = "" THEN BEEP: RETURN
		GOSUB LEE
		FOR I = 1 TO COLUMNX% - 1
		    I$ = CHR$(I + 48)
		    STATUS$(I) = "C" + I$ + "= X" + I$
		NEXT
		DONE% = 0
		RETURN

'---------------------------------------------------  PROCESO DE REGRESION
'Si no se seleccion previamente algn archivo se regresa al men principal
REGR: IF FILE$ = "" THEN BEEP: RETURN
	
	 'Se invoca al subproceso de lectura de valores t de Student
	 GOSUB TST
	
	 FOR I = 1 TO ROWX%: YHATI# = 0
		FOR J = 1 TO COLUMNX%
		    YHATI# = YHATI# + X#(I, J) * B#(J)
		NEXT
		YHAT#(I) = YHATI#:
	 NEXT
    
	'Se invoca la subrutina de SYY
	GOSUB 3950

2800 DX2% = 0
    
	'Despliegue de men (se redefine el tipo y el rea de pantalla)
2805 SCREEN 0: VIEW PRINT 1 TO 25:
	LOCATE 1, 1: COLOR 1, 1
	PRINT STRING$(2000, 32); : COLOR 15, 1
	 LOCATE 6, 11: PRINT "   MENU DE REGRESION  ͻ"
	 LOCATE 7, 11: PRINT "                                    "
	 LOCATE 8, 11: PRINT "   - TABULAR  ESTADISTICAS          "
	 LOCATE 9, 11: PRINT "   - TABULAR  DATOS-AJUSTE          "
	LOCATE 10, 11: PRINT "   - GRAF. DATOS VS. REGRESOR       "
	LOCATE 11, 11: PRINT "   - GRAF. DATOS VS. AJUSTE         "
	LOCATE 12, 11: PRINT "   - GRAF. RESIDUOS VS. Y           "
	LOCATE 13, 11: PRINT "   - GRAF. RESIDUOS VS. REGRESORES  "
	LOCATE 14, 11: PRINT "   - PREDICCION DE VALORES FUTUROS  "
	LOCATE 15, 11: PRINT "   - SALIR                          "
	LOCATE 16, 11: PRINT "                                    "
	LOCATE 17, 11: PRINT " ͼ"
	BEEP
    
	'Despliegue de barra de ayuda
	LOCATE 24, 1: COLOR 15, 2: PRINT STRING$(80, 32);
	LOCATE 24, 24: PRINT "USE LAS TECLAS < ,  > PARA MOVERSE"
	COLOR 14, 1: LOCATE 12, 61: PRINT "F1-AYUDA": COLOR 15, 1
    
	'Desplazamiento del cursor                                       
	X% = 8 + DX2%: Y% = 15: LOCATE X%, Y%, 1, 0, 7
MR:  ANS$ = INKEY$: IF ANS$ = "" THEN GOTO MR
	IF ANS$ = CHR$(0) + CHR$(59) THEN CALL ayuda("REGRESORES"): GOTO 2805
	IF ANS$ = DN$ THEN IF X% < 15 THEN X% = X% + 1 ELSE X% = 8
	IF ANS$ = UP$ THEN IF X% > 8 THEN X% = X% - 1 ELSE X% = 15
  
	'Se invoca la subrutina de lectura de letreros para la barra de ayuda
	CALL letreros("REGRESION", X%)
    
	'Eleccin   
	LOCATE X%, Y%: IF ANS$ <> CHR$(13) THEN GOTO MR
	FLAG% = CSRLIN - 7
	ON FLAG% GOSUB TEST, TDA, GDAT, GOE, GRY, GRX, PVF, R
	IF FLAG% <> 8 THEN 2805
    
	'Regreso a men principal
R:   RETURN

'---------------------------------------------------   CALCULO DE SYY
3950 YY# = 0!: SUM# = 0!
	FOR I = 1 TO ROWX%
	    YY# = YY# + Y#(I) * Y#(I): SUM# = SUM# + Y#(I)
	NEXT
	YBAR# = SUM# / ROWX%: SYY# = YY# - (SUM# * YBAR#)
	BXY# = 0
	'Producto bX' y
	FOR J = 1 TO COLUMNX%
	    BXY# = BXY# + B#(J) * XY#(J)
	NEXT
	SSR# = BXY# - SUM# * YBAR#: SSE# = SYY# - SSR#: DFY% = ROWX% - 1
	DFE% = ROWX% - COLUMNX%: DFR% = DFY% - DFE%: MSR# = SSR# / DFR%
	MSE# = SSE# / DFE%: R2# = SSR# / SYY#: FO# = MSR# / MSE#
	DONE% = 1
    
	'Regreso a submen
	RETURN

'---------------------------------------------------  TABULAR ESTADISTICAS
TEST: CLS : LOCATE , , 0: PRINT
	 PRINT TAB(32); "ANALISIS DE VARIANCIA": PRINT
	 PRINT STRING$(80, "");
	 PRINT "   FUENTE DE"; : PRINT TAB(51); "GRADO DE"
	 PRINT "   VARIACION"; : PRINT TAB(24); "SUMA DE CUADRADOS";
	 PRINT TAB(51); "LIBERTAD";
	 PRINT TAB(63); "CUADRADO MEDIO": PRINT STRING$(80, "");
	 PRINT "   REGRESION";
	 PRINT TAB(21); USING "###########.###"; SSR#;
	 PRINT TAB(48); USING "########"; DFR%;
	 PRINT USING "###########.###"; MSR#
	 PRINT "   RESIDUOS";
	 PRINT TAB(21); USING "###########.###"; SSE#;
	 PRINT TAB(48); USING "########"; DFE%;
	 PRINT USING "###########.###"; MSE#
	 PRINT "   TOTAL";
	 PRINT TAB(21); USING "###########.###"; SYY#;
	 PRINT TAB(48); USING "########"; DFY%
	 PRINT STRING$(80, ""); : PRINT : PRINT
	 PRINT USING "    ESTADISTICA-F  = #######.#### "; FO#
	 PRINT USING "    R-CUADRADO     = #######.####"; R2#
	 PRINT USING "    S-CUADRADO     = #######.####"; MSE#
	 PRINT : PRINT : PRINT "  LA ECUACION AJUSTADA ES:": PRINT
	 PRINT "  Y ="; CSNG(B#(1));
	 FOR I = 2 TO COLUMNX%
		IF B#(I) >= 0 THEN PRINT " + ";
		REM IF B#(I) < 0 THEN PRINT " - "; : B#(I) = -B#(I)
		PRINT CSNG(B#(I)); : RC$ = MID$(STATUS$(I - 1), 5): PRINT RC$;
	 NEXT
	
	 'Despliegue de barra
	 CALL barra

	 CLS : LOCATE , , 0: PRINT
	 PRINT TAB(23); "     COEFICIENTES DE REGRESION     ": PRINT
	 PRINT STRING$(80, ""); : PRINT " N";
	 PRINT TAB(13); "B(I)";
	 PRINT TAB(45); USING "##"; C1%; : PRINT "% I.C.";
	 PRINT TAB(65); "ESTADISTICA T": PRINT STRING$(80, "");
	 FOR I = 1 TO COLUMNX%
		O2C# = MSE# * INV#(I, I): O2C# = SQR(O2C#)
		T1# = TA * O2C#: T2# = 1 / O2C#: PRINT I - 1;
		PRINT TAB(7); USING "######.###"; B#(I);
		PRINT TAB(27); USING "###########.###"; B#(I) - T1#; : PRINT "  --";
		PRINT USING "###########.###"; B#(I) + T1#;
		PRINT USING "############.###"; B#(I) * T2#
	 NEXT
	 PRINT STRING$(80, "");
	
	 'Despliegue de barra
	 BEEP: LOCATE 24, 1: COLOR 15, 2: PRINT STRING$(80, 32);
	 LOCATE 24, 24: PRINT "OPRIMA CUALQUIER TECLA PARA CONTINUAR": COLOR 15, 1
	 DO: LOOP WHILE INKEY$ = ""
	 DX2% = 1
	
	 'Regreso a submen
	 RETURN

'---------------------------------------------------  TABULAR DATOS AJUSTE
TDA: LOCATE , , 0: CALL head
	MAD# = 0!: S# = 0!
	FOR I = 1 TO ROWX%
	    DIFF = Y#(I) - YHAT#(I)
	    PRINT USING "   ###    #########.###     #########.###    #########.###"; I; Y#(I); YHAT#(I); DIFF
	    MAD# = MAD# + ABS(DIFF): S# = S# + DIFF * DIFF
	    IF (I MOD 20 <> 0) AND (I <= ROWX%) THEN 5100
	    'Despliegue de barra
	    CALL barra
	    CLS : CALL head
5100 NEXT
    
	S# = S# / DFE%: MAD# = MAD# / ROWX%
	PRINT : PRINT USING " DESVIACION MEDIA ABSOLUTA =  ######.##"; MAD#;
	PRINT USING " (###.##%)"; CSNG(MAD# / YBAR#) * 100
	PRINT USING " ERROR CUADRADO MEDIO      =  ######.##"; MSE#
    
	'Despliegue de barra
	CALL barra
	CLS : LOCATE , , 0: FST% = 1: LST% = ROWX%: GOSUB 5390
	DX2% = 2
    
	'Regreso a submen
	RETURN

'---------------------------------------------------  PREDICCION DE VALORES FUTUROS
PVF: IF ROW% > ROWX% THEN
	   GOSUB 5310
	   GOTO 5280
	END IF
	CLS : LOCATE 12, 16
	PRINT "NO HAY VALORES FUTUROS DE LA(S) VAR. INDEPENDIENTE(S)"
	'Despliegue de barra
	CALL barra
					    
5280 DX2% = 6
	
	'Regreso a submen
	RETURN

5310 EST% = ROWX% + 1: LST% = ROW%
	FOR I = EST% TO LST%: YHATI# = 0
	    FOR J = 1 TO COLUMNX%
		   YHATI# = YHATI# + X#(I, J) * B#(J)
	    NEXT J
	    YHAT#(I) = YHATI#
	NEXT I

5390 CLS : PRINT "PERIODO      CALCULADO";
	PRINT TAB(38); USING "##%  DE INTERVALO DE  PREDICCION"; C1%;
	COUNT% = 0: PRINT STRING$(80, "");
	FOR I = FST% TO LST%: COUNT% = COUNT% + 1
	    PRINT USING "####"; I;
	    PRINT USING "###########.###"; YHAT#(I);
	    FOR J = 1 TO COLUMNX%
		   TEMP#(J) = 0!
	    NEXT
	    FOR J = 1 TO COLUMNX%
		   FOR K% = 1 TO COLUMNX%
			  TEMP#(J) = TEMP#(J) + X#(I, K%) * INV#(K%, J)
		   NEXT K%
	    NEXT J
	    T1# = 0
	    FOR J = 1 TO COLUMNX%
		   T1# = T1# + TEMP#(J) * X#(I, J)
	    NEXT J
	    T2# = (T1# + 1) * MSE#: T2# = SQR(T2#) * TA
	    PRINT TAB(38); USING "######.###  -- ######.### "; YHAT#(I) - T2#; YHAT#(I) + T2#
	    IF COUNT% MOD 20 <> 0 THEN 5670
	    'Despliegue de barra
	    CALL barra
5670 NEXT I
	'Despliegue de barra
	CALL barra
    
	'Regreso a submen
	RETURN

'---------------------------------------------------  GRAFICACION DE DATOS
GDAT: LOCATE 22, 2: INPUT "CON CUAL REGRESOR C-"; CO%
	 IF CO% = 0 THEN BEEP: GOTO GDAT
GDAT1: LOCATE 23, 2: INPUT "LINEA CONTINUA O SOLO DATOS <C,P>"; TL$
	  TL$ = UCASE$(TL$)
	  IF TL$ <> "P" AND TL$ <> "C" THEN BEEP: GOTO GDAT1
	  CURVE$(1) = TL$
	  IF CO% + 1 > COLUMNX% THEN
	  BEEP: BEEP: BEEP:
	  'Regreso a submen
	  RETURN
	  END IF
	  CLS : FILE2$ = "TEMP.TMP": FILESTK$(1) = FILE2$
	  TITLE$(2) = "REGRESOR C-" + STR$(CO%): CO% = CO% + 1
	 
	  'Abriendo archivo temporal
	  OPEN FILE2$ FOR OUTPUT AS #2
	  PRINT #2, ROWX%; ROWX%; 2
	  FOR J = 1 TO ROWX%
		 PRINT #2, Y#(J);
	  NEXT
	  FOR J = 1 TO ROWX%
		 PRINT #2, X#(J, CO%);
	  NEXT
	  CLOSE #2
	  NOF% = 1:  FLAG1% = 7
	  TITLE$(1) = "DATOS REALES": TITLE$(3) = "VAR.DEPENDIENTE"
	 
	  'Se invoca la subrutina de graficacin
	  CALL graf(FILESTK$(), CURVE$(), NOF%, TITLE$())
	 
	  DX2% = 3
	 
	  'Borrando de disco el archivo temporal
	  KILL "TEMP.TMP"
	 
	  'Regreso a submen
	  RETURN

'---------------------------------------------------  GRAF. DATOS VS. AJUSTE
GOE: CLS : FILE2$ = "TEMP.TMP": FILESTK$(1) = FILE2$
	'Abriendo archivo temporal
	OPEN FILE2$ FOR OUTPUT AS #2
	PRINT #2, ROWX%; ROWX%; 2
	FOR J = 1 TO ROWX%
	   PRINT #2, Y#(J);
	NEXT
	FOR J = 1 TO ROWX%
	    PRINT #2, J;
	NEXT
	CLOSE #2
	FILE2$ = "TEMP1.TMP": FILESTK$(2) = FILE2$
    
	'Abriendo archivo temporal
	OPEN FILE2$ FOR OUTPUT AS #2
	PRINT #2, ROWX%; ROWX%; 2
	FOR J = 1 TO ROWX%
	    PRINT #2, YHAT#(J);
	NEXT
	FOR J = 1 TO ROWX%
	    PRINT #2, J;
	NEXT
	CLOSE #2
	NOF% = 2: CURVE$(1) = "C": CURVE$(2) = "C": FLAG1% = 7
	TITLE$(1) = "OBSERVADOS VS. ESTIMADOS"
	TITLE$(2) = "NO. DE DATO": TITLE$(3) = "VAR.DEPENDIENTE"
    
	'Se invoca la subrutina de graficacin
	CALL graf(FILESTK$(), CURVE$(), NOF%, TITLE$())
    
	DX2% = 3
    
	'Borrando de disco los archivos temporales
	KILL "TEMP.TMP": KILL "TEMP1.TMP"
    
	'Regreso a submen
	RETURN

'---------------------------------------------------  GRAFICA RESID. VS. Y
GRY: CLS :  FILE2$ = "TEMP.DAT": FILESTK$(1) = FILE2$
	'Abriendo archivo temporal
	OPEN FILE2$ FOR OUTPUT AS #2
	PRINT #2, ROWX%; ROWX%; 2
	FOR J = 1 TO ROWX%
	    PRINT #2, Y#(J) - YHAT#(J)
	NEXT
	FOR J = 1 TO ROWX%
	    PRINT #2, Y#(J);
	NEXT
	CLOSE #2
	TITLE$(2) = "VARIABLE DEPENDIENTE"
    
	GOTO graf

'---------------------------------------------------  GRAFICA RESID. VS. X
GRX: LOCATE 22, 2: INPUT "CON CUAL REGRESOR C-"; CO%
	IF CO% = 0 THEN BEEP: GOTO GRX
	IF CO% + 1 > COLUMNX% THEN BEEP: BEEP: BEEP: RETURN
	TITLE$(2) = "REGRESOR C-" + STR$(CO%)
	CO% = CO% + 1
	FILE2$ = "TEMP.DAT": FILESTK$(1) = FILE2$
	'Abriendo archivo temporal
	OPEN FILE2$ FOR OUTPUT AS #2
	PRINT #2, ROWX%; ROWX%; 2
	FOR J = 1 TO ROWX%
	    PRINT #2, Y#(J) - YHAT#(J);
	NEXT
	FOR J = 1 TO ROWX%
	    PRINT #2, X#(J, CO%);
	NEXT
	CLOSE #2

graf: NOF% = 1: CURVE$(1) = "P": FLAG1% = 7
	TITLE$(1) = "REGRESION MULTIPLE": TITLE$(3) = "RESIDUOS"
    
	'Se invoca la subrutina de graficacin
	CALL graf(FILESTK$(), CURVE$(), NOF%, TITLE$())
    
	'Regreso a submen
	RETURN

'---------------------------------------------------  LECTURA DE VALORES T DE STUDENT
TST: TYPE record
		K1 AS SINGLE: K2 AS SINGLE: K3 AS SINGLE
		K4 AS SINGLE: K5 AS SINGLE: K6 AS SINGLE
	END TYPE
	DIM RR AS record
    
	'Se abre el archivo con datos T de Student
	OPEN "TFILE.AYD" FOR RANDOM AS #1 LEN = LEN(RR)
	CODE% = ROWX% - COLUMNX%: IF CODE% > 120 THEN CODE% = 200
	IF (CODE% > 30) AND (CODE% <> 40) AND (CODE% <> 60) AND (CODE% <> 120) AND (CODE% <> 200) THEN 3100
	GET #1, CODE%, RR
	K(1) = RR.K1: K(2) = RR.K2: K(3) = RR.K3
	K(4) = RR.K4: K(5) = RR.K5: K(6) = RR.K6
	TA = K(TIND%)

3100 IF CODE% < 40 THEN CODE1% = 30: CODE2% = 40 ELSE IF CODE% < 60 THEN CODE1% = 40: CODE2% = 60 ELSE CODE1% = 60: CODE2% = 120
	GET #1, CODE1%, RR
	K(1) = RR.K1: K(2) = RR.K2: K(3) = RR.K3
	K(4) = RR.K4: K(5) = RR.K5: K(6) = RR.K6
	T1 = K(TIND%)
	GET #1, CODE2%, RR
	K(1) = RR.K1: K(2) = RR.K2: K(3) = RR.K3
	K(4) = RR.K4: K(5) = RR.K5: K(6) = RR.K6
	T2 = K(TIND%): T3 = (CODE% - CODE1%) * (T1 - T2)
	T4 = (CODE2% - CODE1%): TA = T1 - (T3 / T4)
	CLOSE #1

	FOR I = 1 TO 10
	    FOR J = 1 TO 10
		   XX#(I, J) = 0!
		   INV#(I, J) = 0!
	    NEXT J
	NEXT I
	FOR I = 1 TO 10
	    TEMP#(I) = 0!
	    TEMP1#(I) = 0!
	    B#(I) = 0!
	    XY#(I) = 0!
	NEXT I
	IF STATUS$(1) = "" THEN
	   FOR I = 1 TO COLUMNX% - 1
		  I$ = CHR$(I + 48)
		  STATUS$(I) = "C" + I$ + "= X" + I$
	   NEXT
	END IF

'--------------------------------------------------
'               EL PROBLEMA A RESOLVER ES :         y = Xb + e
'               LA SOLUCION POR MINIMOS CUADRADOS:  b = (X'X-1)X'y

'---------------------------------------------------  X'X    X'  TRANSP.
  FOR K% = 1 TO COLUMNX%
	 FOR J = 1 TO COLUMNX%
		XXKJ# = XX#(K%, J)
		FOR I = 1 TO ROWX%
		    XXKJ# = XXKJ# + X#(I, K%) * X#(I, J)
		NEXT I
		XX#(K%, J) = XXKJ#
	 NEXT J
  NEXT K%

'---------------------------------------------------  PRODUCTO X'X-1
  K% = 1
  FOR I = 1 TO COLUMNX%
	 INV#(I, I) = 1!
  NEXT
  FOR I = 1 TO COLUMNX%
	 TEMP1# = XX#(K%, K%)
	 IF TEMP1# = 0! THEN 3540
	 FOR J = 1 TO COLUMNX%
		INV#(K%, J) = INV#(K%, J) / TEMP1#
		XX#(K%, J) = XX#(K%, J) / TEMP1#
	 NEXT
	 GOTO 3610
3540  L% = 1
	 WHILE (XX#(L%, K%) = 0!) AND (L% < COLUMNX%)
		  L% = L% + 1
	 WEND
	 FOR J = 1 TO COLUMNX%
		INV#(K%, J) = INV#(K%, J) + INV#(L%, J) / XX#(L%, K%)
		XX#(K%, J) = XX#(K%, J) + XX#(L%, J) / XX#(L%, K%)
	 NEXT
3610  FOR M% = 1 TO COLUMNX%
		IF M% = K% THEN 3680
		TEMP2# = XX#(M%, K%)
		FOR J = 1 TO COLUMNX%
		    INV#(M%, J) = INV#(M%, J) - INV#(K%, J) * TEMP2#
		    XX#(M%, J) = XX#(M%, J) - XX#(K%, J) * TEMP2#
		NEXT
3680  NEXT M%
	 K% = K% + 1
  NEXT I

  '-------------------------------------------------  PRODUCTO X'y
  FOR J = 1 TO COLUMNX%
	 FOR I = 1 TO ROWX%
		XY#(J) = X#(I, J) * Y#(I) + XY#(J)
	 NEXT
  NEXT J

'---------------------------------------------------  PRODUCTO  B
  FOR I = 1 TO COLUMNX%
	 FOR J = 1 TO COLUMNX%
		B#(I) = INV#(I, J) * XY#(J) + B#(I)
	 NEXT
  NEXT I
  FOR I = 1 TO ROWX%
	 YHATI# = 0
	 FOR J = 1 TO COLUMNX%
		YHATI# = YHATI# + X#(I, J) * B#(J)
	 NEXT
	 YHAT#(I) = YHATI#
  NEXT I

  'Regreso a submen
  RETURN

 'Subrutina para deteccin de errores
PROCERROR: SELECT CASE ERR
		    CASE 9:  PRINT "INDICE FUERA DE RANGO": SLEEP
		    CASE 6:  PRINT "OVERFLOW": SLEEP
		    CASE 11: PRINT "DIVISION POR CERO": SLEEP
		    CASE 53: LOCATE 22, 30: COLOR 31, 1: PRINT "NO EXISTE EL ARCHIVO"; : BEEP
				   LOCATE 22, 11, 0: COLOR 15, 4: PRINT STRING$(80, 32):
				   LOCATE 23, 8
				   INPUT "TECLEE NOMBRE DE ARCHIVO-DATOS (SIN PUNTO NI EXTENSION)"; FILE$:
				   FILE$ = FILE$ + ".REG"
				   COLOR 15, 1
				   RESUME
		    CASE ELSE
				   LOCATE 24, 1: PRINT "FIN DE PROGRAMA POR ERROR No."; ERR: END
		 END SELECT
		 RESUME NEXT

SUB ayuda (tipo$)
 
  'Subrutina para despliegue de pantallas con ayudas (explicaciones)
 
  LOCATE , , 0
 
  SELECT CASE tipo$
    CASE "MENU"
		  NUM = FREEFILE: CLS
		  'Apertura de archivo de ayuda
		  OPEN "AYUDA1.AYD" FOR INPUT AS NUM
		  'Subrutina de creacin de marcos
		  CALL marco(2, 24, 2, 79, 3, 2, 15)
		  FOR I = 1 TO 17
			 LINE INPUT #NUM, TAYUDA$
			 LOCATE I + 4, 4: PRINT TAYUDA$
		  NEXT
		  CLOSE NUM
		  COLOR 31
		    LOCATE 24, 9: PRINT " < Para continuar con ayuda [F1], para salir cualquier tecla > "
		  COLOR 15
ay:         AM$ = INKEY$: IF AM$ = "" THEN GOTO ay
		  IF AM$ = CHR$(0) + CHR$(59) THEN
			NUM2 = FREEFILE: CLS
			'Apertura de archivo de ayuda
			OPEN "AYUDA2.AYD" FOR INPUT AS NUM
			FOR I = 1 TO 17
			    LINE INPUT #NUM2, TAYUDA$
			    LOCATE I + 4, 2: PRINT TAYUDA$
			NEXT
			CLOSE NUM2
			'Subrutina de creacin de marcos
			CALL marco(2, 24, 2, 79, 3, 2, 15)
		  ELSE
		    EXIT SUB
		  END IF
		  COLOR 31
		    LOCATE 24, 30: PRINT " < Para continuar presione cualquier tecla > "
		  COLOR 15
		  DO: LOOP WHILE INKEY$ = ""
  
    CASE "REGRESORES"
		  NUM3 = FREEFILE: CLS
		  'Subrutina de creacin de marcos
		  CALL marco(2, 24, 2, 79, 3, 2, 15)
		  'Apertura de archivo de ayuda
		  OPEN "AYUDA3.AYD" FOR INPUT AS NUM3
		  FOR I = 1 TO 9
			 LINE INPUT #NUM3, TAYUDA$
			 LOCATE I + 6, 7: PRINT TAYUDA$
		  NEXT
		  CLOSE NUM3
		  COLOR 31
		    LOCATE 24, 30: PRINT " < Para continuar presione cualquier tecla > "
		  COLOR 15
		  DO: LOOP WHILE INKEY$ = ""
  END SELECT

END SUB

SUB barra

 'Subrutina de barra de espera
 
  BEEP: LOCATE 24, 1, 0: COLOR 15, 2: PRINT STRING$(80, 32);
  LOCATE 24, 24: PRINT "OPRIMA CUALQUIER TECLA PARA CONTINUAR": COLOR 15, 1
  DO: LOOP WHILE INKEY$ = ""

END SUB

SUB editor (FILE$, NEWFILE%, X#(), Y#(), ROWX%, ROW%, COLUMNX%)
 
  'Subrutina de edicin de datos

    DIM CMD$(15), NDC(10), XN$(12)
    FMT$ = "#########.###": ORDER$ = "POR COLUMNA": ORDER% = 0
    BLANK2$ = "                    "
    OLDREP$ = "p": B1$ = "     ": B$ = "                         "
    CMD$(1) = "p": CMD$(2) = ")": CMD$(3) = "q": CMD$(4) = "i"
    CMD$(5) = "s": CMD$(6) = "(": CMD$(7) = "r": CMD$(8) = "m"
    CMD$(9) = "k": CMD$(10) = "o": CMD$(11) = "e": MODIF% = 0
    CMD$(12) = "h"
						
    IF NEWFILE% = 1 THEN
	  GOSUB LECTARCH: NDC(1) = ROWX%
	  FOR I = 2 TO COLUMNX%
		 NDC(I) = ROW%
	  NEXT
    END IF
    NOPAG% = 1: NCOL = 1:  OLDXPOS% = 0: OLDYPOS% = 0
    GOSUB PPANTALLA
    GOSUB INDIC
    RPOS% = 3: CPOS% = 0
    GOSUB 2230
    GOSUB 2310
    IF NEWFILE% = 1 THEN GOSUB PRINTCI: GOSUB PRINTCD
    COLOR 14, 1: LOCATE 22, 3: PRINT "F1 - AYUDA": COLOR 7, 1
    LOCATE 23, 3: PRINT "COMANDO ?"; : BEEP
    LOCATE 23, 56: PRINT "Default:     "; OLDREP$
    Z1 = 1
    GOSUB CP
   
    EXIT SUB

'---------------------------------------------------
350 IF MODIF% = 0 THEN RETURN
    REP3$ = RIGHT$(REP$, 1)
    LOCATE 23, 30: PRINT BLANK2$
    LOCATE 23, 30: BEEP: INPUT "SALVAR <S,N>"; REP3$
    IF UCASE$(REP3$) = "N" THEN RETURN
380 GOSUB SAVEARCH

    RETURN

'---------------------------------------------------
PPANTALLA:
CLS : LOCATE 22, 56: PRINT ORDER$: COLOR 7, 1
	 LOCATE 2, 1: PRINT STRING$(53, "");
	 LOCATE 21, 1:  PRINT STRING$(77, "");
	 FOR I = 1 TO 23
		LOCATE I, 28: PRINT "": LOCATE I, 53: PRINT ""
	 NEXT
	 RETURN

'---------------------------------------------------
INDIC: FOR I = 1 TO 18
		 LOCATE I + 2, 2, 1, 7, 7
		 PRINT USING "###"; I + 18 * (NOPAG% - 1); : PRINT ":"
	  NEXT
	  C% = 2 * (NCOL - 1)
	  IF C% = 0 THEN C1$ = "(Y )" ELSE C1$ = "(X" + CHR$(C% + 48) + ")"
	  C% = C% + 1: C2$ = "(X" + CHR$(C% + 48) + ")"
	  LOCATE 1, 21: PRINT C1$: LOCATE 1, 46: PRINT C2$
	  RETURN

'---------------------------------------------------
PRINTCI: T1% = 18 * (NOPAG% - 1)
	    FOR I = 1 TO 18
		   K% = I + T1%: LOCATE I + 2, 7
		   IF K% > NDC(C%) THEN PRINT "                    ": GOTO 890
		   IF NCOL = 1 THEN
			 PRINT USING FMT$; X#(K%, 1)
		   ELSE
			 IF C% <= COLUMNX% THEN PRINT USING FMT$; X#(K%, C%)
		   END IF
890      NEXT
	    RETURN

'---------------------------------------------------
PRINTCD: T1% = 18 * (NOPAG% - 1)
	    FOR I = 1 TO 18
		   K% = I + T1%: LOCATE I + 2, 32
		   IF K% > NDC(C% + 1) THEN PRINT "                    ": GOTO 980
		   IF C% + 1 <= COLUMNX% THEN PRINT USING FMT$; X#(K%, C% + 1)
980      NEXT
	    RETURN

'--------------------------------------------------- Lectura de archivo
LECTARCH: Nf = FREEFILE: OPEN FILE$ FOR INPUT AS #Nf
		INPUT #Nf, ROWX%, ROW%, COLUMNX%
		FOR I = 1 TO ROWX%
		    INPUT #Nf, X#(I, 1)
		NEXT
		FOR J = 2 TO COLUMNX%
		    FOR I = 1 TO ROW%
			   INPUT #Nf, X#(I, J)
		NEXT I, J
		CLOSE #Nf
		RETURN

'-------------------------------------------------- Salvado de archivo     
SAVEARCH: ROWX% = NDC(1): ROW% = NDC(2)
		Nf = FREEFILE: OPEN FILE$ FOR OUTPUT AS #Nf
		PRINT #Nf, ROWX%; ROW%; COLUMNX%
		FOR I = 1 TO ROWX%
		    PRINT #Nf, X#(I, 1)
		NEXT
		FOR J = 2 TO COLUMNX%
		    FOR I = 1 TO ROW%
			   PRINT #Nf, X#(I, J);
		NEXT I, J
		CLOSE #Nf: MODIF% = 0
		RETURN

'-------------------------------------------------- MOV. HACIA ABAJO
DN: REP3$ = RIGHT$(REP$, 1): MID$(REP3$, 1) = " ": Nrc = VAL(REP3$)
    IF Nrc <= 0 THEN Nrc = 1
    NOPAG% = NOPAG% + Nrc
    IF NOPAG% > 12 THEN NOPAG% = 12: GOSUB PROB
    QUIT% = 1: GOSUB INDIC: RPOS% = 3
    CPOS% = 0: GOSUB 2230: GOSUB 2310: GOSUB PRINTCI: GOSUB PRINTCD
    RETURN

'-------------------------------------------------- MOV. HACIA ARRIBA
UP: REP3$ = RIGHT$(REP$, 1): MID$(REP3$, 1) = " ": Nrc = VAL(REP3$)
    IF Nrc <= 0 THEN Nrc = 1
    NOPAG% = NOPAG% - Nrc
    IF NOPAG% < 1 THEN NOPAG% = 1: GOSUB PROB
    QUIT% = 1: GOSUB INDIC: RPOS% = 3: CPOS% = 0: GOSUB 2230: GOSUB 2310
    GOSUB PRINTCI: GOSUB PRINTCD
    RETURN

'-------------------------------------------------- MOV. HACIA LA DERECHA
DER: IF NCOL = 5 THEN GOSUB PROB: RETURN
	REP3$ = RIGHT$(REP$, 1): MID$(REP3$, 1) = " ": Nrc = VAL(REP3$)
	IF Nrc = 0 THEN Nrc = 1
	NCOL = NCOL + Nrc
	IF NCOL > 5 THEN NCOL = 5: GOSUB PROB
	QUIT% = 1: GOSUB INDIC
	RPOS% = 3: CPOS% = 0: GOSUB 2230: GOSUB 2310
	GOSUB PRINTCI: GOSUB PRINTCD
	RETURN

'-------------------------------------------------- MOV. HACIA LA IZQ.
IZQ: IF NCOL = 1 THEN GOSUB PROB: RETURN
	REP3$ = RIGHT$(REP$, 1): MID$(REP3$, 1) = " ": Nrc = VAL(REP3$)
	IF Nrc = 0 THEN Nrc = 1
	NCOL = NCOL - Nrc
	IF NCOL < 1 THEN NCOL = 1: GOSUB PROB
	QUIT% = 1: GOSUB INDIC
	RPOS% = 3: CPOS% = 0: GOSUB 2230: GOSUB 2310
	GOSUB PRINTCI: GOSUB PRINTCD
	RETURN

'--------------------------------------------------
'               CONTROL PRINCIPAL
'--------------------------------------------------
CP: LOCATE 23, 69: PRINT B1$: LOCATE 23, 69: PRINT OLDREP$
    LOCATE 23, 12: PRINT B$: LOCATE 23, 12
LEVIC: REP$ = INKEY$: IF REP$ = "" THEN GOTO LEVIC
    IF REP$ = CHR$(0) + CHR$(59) THEN GOSUB AYED: GOTO CP
    REP2$ = RIGHT$(REP$, 1): T1% = ASC(REP2$)
    IF T1% >= 43 AND T1% <= 57 THEN LOCATE 24, 10: COLOR 0, 7: COLOR 7, 1: GOTO NUMI
    T1% = T1% OR 32: REP2$ = CHR$(T1%)
    TT = 0: GOSUB VALIDA
    IF VALID% = 0 THEN GOTO CP ELSE VALID% = 0: OLDREP$ = RIGHT$(REP$, 1)
    ON FLAG% GOSUB CHANGR, CHANGC, DN, UP, 380, DELD, INSD, DER, IZQ, ORDN, 350, CHANGR1
    IF REP2$ <> "e" THEN GOTO CP ELSE 2050

'--------------------------------------------------
NUMO: LOCATE 24, 10: PRINT "              ":

WHILE REP2$ <> "e"
	
	 NEWDATA = REP: MODIF% = 1
	 IF QUIT% = 1 OR OLDXPOS% = 0 THEN
	    QUIT% = 0: GOTO 1720
	 ELSE
	    LOCATE OLDXPOS%, OLDYPOS%, 0: PRINT USING FMT$; OLDDATA
	 END IF

1720  LOCATE 23, 12: PRINT B$
	 R% = RPOS% - 2 + 18 * (NOPAG% - 1)
	 IF CPOS% <> 0 THEN
	    X#(R%, C% + 1) = NEWDATA: YPOS% = 32: FLAG% = 1
	 ELSE
	    IF C% MOD 2 <> 0 THEN
		  IF C% = 1 THEN X#(R%, C%) = NEWDATA: YPOS% = 7: FLAG% = 2
		  X#(R%, C%) = NEWDATA: YPOS% = 7: FLAG% = 3
	    ELSE
		  X#(R%, C%) = NEWDATA: YPOS% = 32: FLAG% = 1
	    END IF
	 END IF
	 ON FLAG% GOTO 1760, 1820, 1790

1760  IF R% > NDC(C% + 1) THEN NDC(C% + 1) = R%
	 IF C% + 1 > COLUMNX% THEN COLUMNX% = C% + 1
	 GOTO 1840

1790  IF R% > NDC(C%) THEN NDC(C%) = R%
	 IF C% > COLUMNX% THEN COLUMNX% = C%
	 GOTO 1840

1820  IF R% > NDC(1) THEN NDC(1) = R%
	 IF C% > COLUMNX% THEN COLUMNX% = C%

1840  XPOS% = R% - 18 * (NOPAG% - 1) + 2
	 LOCATE XPOS%, YPOS%: COLOR 14, 1, 0: PRINT USING FMT$; NEWDATA
	 COLOR 7, 1, 0
	 IF ORDER% = 1 THEN FWD% = 1: GOSUB 2080: GOTO 1910
	 IF CPOS% = 1 THEN FWD% = 1: GOSUB 2080
	 GOSUB CHANGC
	 IF Z1 = 0 THEN OLDYPOS% = 32

1910  POSI% = OLDYPOS%: OLDYPOS% = YPOS%: OLDXPOS% = XPOS%: OLDDATA = NEWDATA

1920  LOCATE 23, 69: PRINT B1$: LOCATE 23, 69: PRINT OLDREP$
	 LOCATE 23, 12: PRINT B$
	 IF ZZ = 1 THEN GOTO PROM

NUMI: Z1 = Z1 - 1
	 IF CPOS% = 1 THEN POSI% = 32 ELSE POSI% = 7
	 LOCATE RPOS%, POSI%: PRINT REP$: CN$ = ""
	 FOR S = 1 TO 12
GATO:     XN$(S) = INKEY$: IF XN$(S) = "" THEN GOTO GATO
		IF ASC(RIGHT$(XN$(S), 1)) < 43 OR ASC(RIGHT$(XN$(S), 1)) > 57 THEN ZZ = 1: GOTO PRIM
		LOCATE RPOS%, POSI% + S: PRINT XN$(S)
		CN$ = CN$ + XN$(S): HN = VAL(REP$ + CN$): REP = HN
	 NEXT S
	 GOTO PROM

PRIM: IF S = 1 THEN REP = VAL(REP$)
	 REP$ = XN$(S): GOTO NUMO

PROM: IF REP$ = "" THEN REP$ = OLDREP$
	 REP2$ = LEFT$(REP$, 1)
	 IF REP2$ = " " THEN REP2$ = OLDREP$: GOTO 2000
	 IF REP2$ = " " OR REP2$ = "" THEN REP2$ = "D"
	 T1% = ASC(REP2$)
	 IF T1% >= 43 AND T1% <= 57 THEN ZZ = 0: GOTO NUMO
	 T1% = T1% OR 32: REP2$ = CHR$(T1%)

2000  TT = 1: GOSUB VALIDA
	 IF VALID% = 0 THEN GOTO CP ELSE VALID% = 0: OLDREP$ = REP$
	 ON FLAG% GOSUB CHANGR, CHANGC, DN, UP, 380, DELD, INSD, DER, IZQ, ORDN, 350, CHANGR1
	 IF REP2$ <> "e" THEN 1920

WEND

2050  RETURN

'--------------------------------------------------
CHANGR: REP3$ = RIGHT$(REP$, 1): MID$(REP3$, 1) = " ": FWD% = VAL(REP3$): IF FWD% = 0 THEN FWD% = 1

2080 OLDRPOS% = RPOS%: RPOS% = RPOS% + FWD%: Nrc = 0
	IF RPOS% = 20 THEN SOUND 400, 3
	IF RPOS% > 2 THEN 2160

2110 IF RPOS% < 3 THEN RPOS% = RPOS% + 18: Nrc = Nrc + 1: GOTO 2110
	NOPAG% = NOPAG% - Nrc: IF NOPAG% < 1 THEN GOSUB PROB: NOPAG% = 1: RPOS% = 3
	IF NOPAG% = 1 THEN RPOS% = 3: GOTO 2210
	QUIT% = 1
	GOSUB INDIC: GOSUB PRINTCI: GOSUB PRINTCD: GOSUB 2310: GOTO 2230

2160 IF RPOS% < 21 THEN 2210

2170 IF RPOS% > 20 THEN RPOS% = RPOS% - 18: Nrc = Nrc + 1: GOTO 2170
	NOPAG% = NOPAG% + Nrc
	IF NOPAG% > 12 THEN NOPAG% = 12: GOSUB PROB
	QUIT% = 1
	GOSUB INDIC: GOSUB PRINTCI: GOSUB PRINTCD: GOSUB 2310: GOTO 2230

2210 LOCATE OLDRPOS%, 2, 0: PRINT USING "###:"; OLDRPOS% - 2 + 18 * (NOPAG% - 1);

2230 COLOR 0, 7: LOCATE RPOS%, 2, 0: PRINT USING "###:"; RPOS% - 2 + 18 * (NOPAG% - 1);
	COLOR 7, 1
	RETURN

'--------------------------------------------------
CHANGR1: REP3$ = RIGHT$(REP$, 1): MID$(REP3$, 1) = " ": FWD% = VAL(REP3$): IF FWD% = 0 THEN FWD% = -1

12080    OLDRPOS% = RPOS%: RPOS% = RPOS% + FWD%: Nrc = 0
	    IF RPOS% = 20 THEN SOUND 400, 3
	    IF RPOS% > 2 THEN 12160

12110    IF RPOS% < 3 THEN RPOS% = RPOS% + 18: Nrc = Nrc + 1: GOTO 12110
	    NOPAG% = NOPAG% - Nrc: IF NOPAG% < 1 THEN GOSUB PROB: NOPAG% = 1: RPOS% = 3
	    IF NOPAG% = 1 THEN RPOS% = 3: GOTO 12210
	    QUIT% = 1
	    GOSUB INDIC: GOSUB PRINTCI: GOSUB PRINTCD: GOSUB 2310: GOTO 12230

12160    IF RPOS% < 21 THEN 12210

12170    IF RPOS% > 20 THEN RPOS% = RPOS% - 18: Nrc = Nrc + 1: GOTO 12170
	    NOPAG% = NOPAG% + Nrc
	    IF NOPAG% > 12 THEN NOPAG% = 12: GOSUB PROB
	    QUIT% = 1
	    GOSUB INDIC: GOSUB PRINTCI: GOSUB PRINTCD: GOSUB 2310: GOTO 2230

12210    LOCATE OLDRPOS%, 2, 0: PRINT USING "###:"; OLDRPOS% - 2 + 18 * (NOPAG% - 1);

12230    COLOR 0, 7: LOCATE RPOS%, 2, 0: PRINT USING "###:"; RPOS% - 2 + 18 * (NOPAG% - 1);
	    COLOR 7, 1
	    RETURN

'--------------------------------------------------
CHANGC: IF COL% = 1 THEN GOSUB PROB: RETURN
	   CPOS% = CPOS% + 1: IF CPOS% > 1 THEN CPOS% = 0
	   IF CPOS% = 0 THEN LOCATE 1, 46, 0: PRINT C2$;  ELSE LOCATE 1, 21, 0: PRINT C1$
2310    COLOR 0, 7: IF CPOS% = 0 THEN LOCATE 1, 21, 0: PRINT C1$ ELSE LOCATE 1, 46, 0: PRINT C2$
	   COLOR 7, 1
	   RETURN

'--------------------------------------------------
VALIDA: I = 0
	   WHILE I < 12 AND VALID% = 0
		    I = I + 1
		    IF REP2$ = CMD$(I) THEN FLAG% = I: VALID% = 1
	   WEND
	   IF REP2$ = CHR$(0) + CHR$(80) THEN FLAG% = 3: VALID% = 1
	   IF VALID% = 0 THEN GOSUB PROB
	   RETURN

'--------------------------------------------------
ORDN: IF ORDER% = 1 THEN
	    ORDER% = 0: ORDER$ = "POR COLUMNA"
	 ELSE
	    ORDER% = 1: ORDER$ = "POR RENGLON"
	 END IF
	 LOCATE 22, 56: COLOR 15, 1: PRINT ORDER$: BEEP: COLOR 7, 1
	 RETURN

'--------------------------------------------------
DELD: REP3$ = RIGHT$(REP$, 1): MID$(REP3$, 1) = " ": COUNT% = VAL(REP3$): IF COUNT% = 0 THEN COUNT% = 1
	 IF ORDER% = 0 THEN N% = 2 ELSE N% = 1
	 LOCATE 23, 30: PRINT "BORRANDO"; COUNT% * N%; "DATOS...": BEEP
	 LOCATE 23, 12: PRINT B$
	 R% = RPOS% - 2 + 18 * (NOPAG% - 1)
	 FOR J = 1 TO N%
		IF CPOS% <> O THEN T1% = C% + 1: FLAG% = 2 ELSE IF C% = 1 THEN T1% = 1: FLAG% = 1 ELSE T1% = C%: FLAG% = 1
		FOR I = R% + COUNT% TO NDC(T1%)
		    X#(I - COUNT%, T1%) = X#(I, T1%)
		NEXT
		NDC(T1%) = NDC(T1%) - COUNT%
		T1% = CPOS%
		ON FLAG% GOSUB PRINTCI, PRINTCD
		IF ORDER% = 0 THEN GOSUB CHANGC
	 NEXT J
	 LOCATE 23, 30: PRINT BLANK2$: BEEP
	 RETURN

'--------------------------------------------------
INSD: REP3$ = RIGHT$(REP$, 1): MID$(REP3$, 1) = " ": COUNT% = VAL(REP3$): IF COUNT% = 0 THEN COUNT% = 1
	 IF ORDER% = 0 THEN N% = 2 ELSE N% = 1
	 LOCATE 23, 30: PRINT "INSERTAR"; COUNT% * N%; "DATOS ...": BEEP
	 LOCATE 23, 12: PRINT "            "
	 R% = RPOS% - 2 + 18 * (NOPAG% - 1)
	 FOR J = 1 TO N%
		IF CPOS% <> 0 THEN T1% = C% + 1: FLAG% = 2: YPOS% = 32 ELSE IF C% = 1 THEN T1% = 1: FLAG% = 1: YPOS% = 7 ELSE T1% = C%: FLAG% = 1: YPOS% = 7
		FOR I = NDC(T1%) + COUNT% TO R% + COUNT% STEP -1
		    X#(I, T1%) = X#(I - COUNT%, T1%)
		NEXT
		FOR I = R% TO R% + COUNT% - 1
		    X#(I, T1%) = 0
		NEXT
		NDC(T1%) = NDC(T1%) + COUNT%
		T1% = CPOS%
		ON FLAG% GOSUB PRINTCI, PRINTCD
		FOR I = R% TO R% + COUNT% - 1
		    IF I + 2 > 20 THEN 2840 ELSE LOCATE I + 2, YPOS%
		    COLOR 0, 7: PRINT "                   "
2840      NEXT
		COLOR 7, 1
		IF ORDER% = 0 THEN GOSUB CHANGC
	 NEXT J
	 LOCATE 23, 30: PRINT BLANK2$: BEEP
	 RETURN

'--------------------------------------------------
PROB: IF TT = 1 THEN GOTO ETI: LOCATE 23, 30: PRINT "COMANDO INVALIDO..."
	 FOR F = 300 TO 500 STEP 100
		SOUND F, 2: SOUND 32767, 2
	 NEXT
	 LOCATE 23, 30: PRINT BLANK2$
ETI:  RETURN

'-------------------------------------------------- Despliegue de ayuda
AYED: LOCATE 1, 60: PRINT "C O M A N D O S": COLOR 11, 1
	 LOCATE 3, 56: PRINT "[TAB] CAMBIA A LA": LOCATE 6, 56: PRINT "[INS] INSERTA  UN"
	 LOCATE 4, 56: PRINT "      OTRA COLUMNA": LOCATE 7, 56: PRINT "      NUEVO RENGLON"
	 LOCATE 9, 56: PRINT "[BACKSPACE] BORRA EL": LOCATE 12, 56: PRINT "[O]   CAMBIA EL ORDEN EN"
	 LOCATE 10, 56: PRINT "            RENGLON": LOCATE 13, 56: PRINT "      EN QUE SE ADMITIRA "
	 LOCATE 14, 56: PRINT "      EL NUEVO DATO"
	 LOCATE 16, 56: PRINT "[S]   SALVA LOS DATOS "
	 LOCATE 18, 56: PRINT "[E]   SALIDA AL MENU"
	 LOCATE 19, 56: PRINT "      PRINCIPAL"
	 DO: LOOP WHILE INKEY$ = ""
	 FOR I = 1 TO 19
		LOCATE I, 56: PRINT STRING$(24, 32);
	 NEXT
	
	 RETURN

END SUB

SUB enrolla

  'Subrutina que despliega una cortina para presentacin de ttulos
 
   'Creacin de la cortina
	CLS
	VIEW PRINT
	COLOR 3, 1
	  FOR AR = 8 TO 70
		 FOR RA = 4 TO 21
			COLOR 7
			  LOCATE RA + 1, AR + 1: PRINT ""
			COLOR 3
			  LOCATE RA, AR: PRINT ""
	  NEXT RA, AR
 
   'Letreros
	COLOR 0, 3
	  LOCATE 7, 22: PRINT "T E C N I C A S    A V A N Z A D A S "
	  LOCATE 9, 25: PRINT "D E    P R O G R A M A C I O N"
	  LOCATE 13, 30: PRINT "C A P I T U L O   V I"
	  LOCATE 17, 23: PRINT "PROGRAMA PARA GRAFICACION Y ANALISIS"
	  LOCATE 18, 30: PRINT "DE REGRESION MULTIPLE"
	COLOR 31, 0
	  LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
  
   'Pausa de 2.5 segundos
	SLEEP 2.5

END SUB

SUB graf (FILESTK$(), CURVE$(), NOF%, TITLE$())

'Subrutina para despliegue de grficas

'--------------------------------------------------
'  OPCIONES:       PARA EL TIPO DE CURVA (L,P,C,S)
'                  LINE,POINT,CURVE,STEP
'--------------------------------------------------
  
  DIM X(300), Y(300), B(300), C(300), D(300)
  SCREEN 8: HDPOS% = 44: COLOR 15, 3

  FOR L% = 1 TO NOF%
	 FILE$ = FILESTK$(L%): GOSUB LEEARCH
	 IF L% = 1 THEN XMIN = X(1): XMAX = XMIN: YMIN = Y(1): YMAX = YMIN
	 FOR I = 1 TO NOD%
		IF X(I) < XMIN THEN XMIN = X(I) ELSE IF X(I) > XMAX THEN XMAX = X(I)
		IF Y(I) < YMIN THEN YMIN = Y(I) ELSE IF Y(I) > YMAX THEN YMAX = Y(I)
	 NEXT I
  NEXT L%
  CALL letgraf(XMIN, XMAX, YMIN, YMAX, TITLE$())
  range = XMAX - XMIN: PTR% = 1: CLS 0: GOSUB G840
  ERASE X, Y, B, C, D
  EXIT SUB

'-------------------------------------------------- RUTINAS DE GRAFICACION
G840: ORIGY% = 12: ORIGX% = 142: DX% = 80: DY% = 40
	 TEMP4% = ORIGY% + 3 * DY%
870   VIEW (0, 0)-(639, 163):  CLS : VIEW
	 X% = ORIGX%
	 FOR I = 1 TO 25
		IF ((I - 1) MOD 4 = 0) THEN LINE (X%, 132)-(X%, 135), 1
		X% = X% + DX% / 4
	 NEXT
	 T1% = ORIGX% - 8: T2% = ORIGY%
	 FOR I = 1 TO 2
		T2% = T2% + DY%: LINE (T1%, T2%)-(ORIGX%, T2%), 1
	 NEXT
	 FOR I = 1 TO 11
		T1% = ORIGY% + I * 10: LINE (143, T1%)-(623, T1%), , , &H4444
	 NEXT
	 FOR I = 1 TO 23
		T1% = ORIGX% + I * 20: LINE (T1%, 12)-(T1%, 132), , , &HAAAA
	 NEXT
	 LINE (ORIGX%, ORIGY%)-(ORIGX% + 6 * DX%, TEMP4%), 1, B
	 X% = ORIGX%:  Y% = ORIGY%
	 FOR L% = 1 TO NOF%
		IF NOF% = 1 THEN 960
		FILE$ = FILESTK$(L%): GOSUB LEEARCH
960       XINDEX = XMIN: GOSUB PLOT
		IF L% = 1 THEN GOSUB 1120
		IF L% <> NOF% THEN PTR% = 1
	 NEXT L%
	
	 'Puntos observados
	 LOCATE 22, 10: PRINT "DATOS OBSERVADOS"
	 LINE (230, 171)-(260, 171), 1
	 CIRCLE (235, 171), 2, 14, 0, 6.28, 5 / 12
	 CIRCLE (255, 171), 2, 14, 0, 6.28, 5 / 12
	
	 'Puntos estimados
	 LOCATE 23, 10: PRINT "DATOS ESTIMADOS"
	 LINE (230, 180)-(260, 180), 1
	 LINE (234, 181)-(234 + 6, 181): LINE -(234 + 3, 181 - 3): LINE -(234, 181)
	 LINE (254, 181)-(254 + 6, 181): LINE -(254 + 3, 181 - 3): LINE -(254, 181)
	
	 LINE (568, 180)-(634, 195), 1, B
	 LOCATE 24, 73: PRINT "S SALIR"; : BEEP
	 
1020  ANS$ = INKEY$: IF ANS$ = "" THEN GOTO 1020
	 IF UCASE$(ANS$) = "S" THEN RETURN ELSE GOTO 1020
1120  IF (YMAX * YMIN < 0) THEN TEMP = (-1 * YMIN / (YMAX - YMIN)) * 120 ELSE GOTO 1190
	 DELTAY% = CINT(TEMP)
	 LINE (ORIGX%, TEMP4% - DELTAY%)-(ORIGX% + 6 * DX%, TEMP4% - DELTAY%)
	 IF (XMAX * XMIN < 0) THEN TEMP = (-1 * XMIN / (XMAX - XMIN)) * 480 ELSE GOTO 1190
	 DELTAX% = CINT(TEMP)
	 LINE (ORIGX% + DELTAX%, ORIGY%)-(ORIGX% + DELTAX%, TEMP4%)
1190  YINDEX = YMAX
	 TEMP = (YMAX - YMIN) / 3
	 P% = LEN(TITLE$(1)): P% = HDPOS% - (P% * .5)
	 LOCATE 1, 1: PRINT TAB(P%); TITLE$(1)
	 FOR I = 1 TO 4
		PRINT USING "#############.##"; YINDEX
		IF I <> 4 THEN FOR J = 1 TO 4: PRINT : NEXT J
		IF I < 3 THEN YINDEX = YINDEX - TEMP ELSE YINDEX = YMIN
	 NEXT
	 XINDEX = XMIN: XINCR = (XMAX - XMIN) / 24
	 PRINT USING "#################.##"; XINDEX;
	 FOR I = 1 TO 6
		XINDEX = XINDEX + XINCR * 4
		PRINT USING "#######.##"; XINDEX;
	 NEXT

' -------------------------------------------------- IMPRIME TITULOS DE EJES
	 P% = LEN(TITLE$(2)): P% = HDPOS% - (P% * .5)
	 LOCATE 20, 1: PRINT TAB(P%); TITLE$(2);
	 T1% = LEN(TITLE$(3)): P% = 9 - (T1% * .5)
	 FOR I = 1 TO T1%
		T1$ = MID$(TITLE$(3), I, 1): LOCATE P% + I, 6: PRINT T1$
	 NEXT
	 RETURN

'--------------------------------------------------- LOCALIZA PUNTOS EN LAS GRAFICAS
PLOT: TEMP2 = 1 / (YMAX - YMIN): TEMP3 = 1 / (XMAX - XMIN)
	 T% = L%:  REP$ = LEFT$(CURVE$(L%), 1)
AT:   IF T% > 3 THEN T% = T% - 3:  GOTO AT
	 IF REP$ = "C" THEN GOSUB SPL
	 COUNT% = 0: NDP% = 0
	 WHILE (PTR% <= NOD%) AND (X(PTR%) <= XMAX)
		  IF X(PTR%) < XMIN THEN 1650
		  IF Y(PTR%) < YMIN OR Y(PTR%) > YMAX THEN 1650
		  NDP% = NDP% + 1
		  TEMP1 = ABS((X(PTR%) - XMIN) * TEMP3) * 480
		  TEMP = ABS((Y(PTR%) - YMIN) * TEMP2) * 120
		  DELTAY% = CINT(TEMP): DELTAX% = CINT(TEMP1)
		  OLDY% = Y%: OLDX% = X%
		  Y% = TEMP4% - DELTAY%: X% = ORIGX% + DELTAX%
		  IF COUNT% = 0 THEN
			OLDY% = Y%: OLDX% = X%: PSET (X%, Y%)
			COUNT% = 1
		  END IF
		  IF REP$ = "P" THEN 1600 ELSE IF REP$ = "S" THEN LINE -(X%, OLDY%)
		  LINE -(X%, Y%), 1
1600        IF T% = 1 THEN
			'Puntos observados
			CIRCLE (X%, Y%), 2, 14, 0, 6.28, 5 / 12
		  ELSEIF T% = 2 THEN
			    'Puntos estimados
				LINE (X%, Y%)-(X% + 6, Y%): LINE -(X% + 3, Y% - 3): LINE -(X%, Y%)
			  ELSE
				LINE (X%, Y%)-(X% + 6, Y% - 3), 1, B: PSET (X%, Y%)
		  END IF
		  GOTO 1640
1630        PSET (X%, Y%)
1640        IF REP$ = "C" THEN GOSUB GS
1650        PTR% = PTR% + 1
	 WEND
	 LASTX% = X%: LASTY% = Y%
	 RETURN

' -------------------------------------------------- SPLINE CUBICO
SPL: DIM H(200), A(200), L(200), U(200), Z(200)
	FOR I = 1 TO NOD% - 1
	    H(I) = X(I + 1) - X(I)
	    IF H(I) <= 0 THEN REP$ = "P": RETURN
	NEXT
	FOR I = 2 TO NOD% - 1
	    T1 = Y(I + 1) * H(I - 1): T2 = Y(I) * (X(I + 1) - X(I - 1))
	    T3 = Y(I - 1) * H(I)
	    A(I) = 3 * (T1 - T2 + T3) / (H(I - 1) * H(I))
	NEXT
	L(1) = 1: U(1) = 0: Z(1) = 0
	FOR I = 2 TO NOD%
	    L(I) = 2 * (X(I + 1) - X(I - 1)) - H(I - 1) * U(I - 1)
	    U(I) = H(I) / L(I): Z(I) = (A(I) - H(I - 1) * Z(I - 1)) / L(I)
	NEXT
	L(NOD%) = 1: Z(NOD%) = 0: C(NOD%) = 0
	FOR J = NOD% - 1 TO 1 STEP -1
	    C(J) = Z(J) - U(J) * C(J + 1): T1 = (Y(J + 1) - Y(J)) / H(J)
	    T2 = H(J) * (C(J + 1) + 2 * C(J)) / 3
	    B(J) = T1 - T2: D(J) = (C(J + 1) - C(J)) / (3 * H(J))
	NEXT J
	ERASE H, A, L, U, Z
	RETURN

'--------------------------------------------------- GRAFICACION DEL SPLINE
GS: IF PTR% + 1 > NOD% OR X(PTR% + 1) > XMAX THEN RETURN
    T1 = (XMAX - XMIN) / 480: T2 = X(PTR%)
    TEMP1 = ABS((X(PTR% + 1) - XMIN) * TEMP3) * 480
    DELTAX% = CINT(TEMP1): XNEXT% = ORIGX% + DELTAX%

2190 X% = X% + 2
	IF X% >= XNEXT% THEN RETURN
	T2 = T2 + 2 * T1: T4 = T2 - X(PTR%)
	T3 = Y(PTR%) + B(PTR%) * T4 + C(PTR%) * T4 * T4 + D(PTR%) * T4 * T4 * T4
	TEMP = ABS((T3 - YMIN) * TEMP2) * 120
	DELTAY% = CINT(TEMP): Y% = TEMP4% - DELTAY%
	IF Y% > 132 THEN Y% = 132 ELSE IF Y% < 12 THEN Y% = 12
	LINE -(X%, Y%), 1: GOTO 2190
	
	RETURN

' -------------------------------------------------- LECTURA DE ARCHIVOS
LEEARCH: Nf = FREEFILE: OPEN FILE$ FOR INPUT AS #Nf
	    INPUT #Nf, NOD%, T1%, T2%
	    FOR J = 1 TO NOD%
		   INPUT #Nf, Y(J)
	    NEXT
	    FOR J = 1 TO NOD%
		   INPUT #Nf, X(J)
	    NEXT
	    CLOSE #Nf
	    RETURN

END SUB

SUB head

'Subrutina encabezado
 CLS : PRINT "    DATO         OBSERVADO       PREDICCION         RESIDUO"
 PRINT STRING$(80, "");

END SUB

SUB letgraf (XMIN, XMAX, YMIN, YMAX, TITLE$())

'Subrutina para despliegue de letreros en grficas
 
  LOCATE 10, 10: PRINT "ENCABEZADO DE GRAFICA ="; TITLE$(1)
  LOCATE 11, 10: PRINT "LETRERO EN EJE X      ="; TITLE$(2)
  LOCATE 12, 10: PRINT "LETRERO EN EJE Y      ="; TITLE$(3)

  LOCATE 15, 10: PRINT "VALOR MINIMO EN X   = "; XMIN
  LOCATE 16, 10: PRINT "VALOR MAXIMO EN X   = "; XMAX
  LOCATE 17, 10: PRINT "VALOR MINIMO EN Y   = "; YMIN
  LOCATE 18, 10: PRINT "VALOR MAXIMO EN Y   = "; YMAX

  LOCATE 22, 10: PRINT "DESEA ALGUN CAMBIO <S,N> ?"
  RES$ = INPUT$(1): IF UCASE$(RES$) <> "S" THEN EXIT SUB

  CLS
  LOCATE 10, 10: INPUT "ENCABEZADO DE LA GRAFICA ="; T1$
  IF T1$ <> "" THEN TITLE$(1) = T1$
  IF LEN(TITLE$(1)) > 60 THEN TITLE$(1) = LEFT$(TITLE$(1), 60)

  LOCATE 11, 10: INPUT "TITULO EN EJE X          ="; T1$
  IF T1$ <> "" THEN TITLE$(2) = T1$
  IF LEN(TITLE$(2)) > 60 THEN TITLE$(2) = LEFT$(TITLE$(2), 60)

  LOCATE 12, 10: INPUT "TITULO EN EJE Y          ="; T1$
  IF T1$ <> "" THEN TITLE$(3) = T1$
  IF LEN(TITLE$(3)) > 15 THEN TITLE$(3) = LEFT$(TITLE$(3), 15)
 
  LOCATE 15, 10: PRINT "MINIMO EN X = ("; XMIN; ")"; : INPUT T1$
  IF T1$ <> "" THEN TEMP = VAL(T1$) ELSE TEMP = XMIN
  IF T1$ <> "" THEN TEMP3 = XMIN: XMIN = TEMP

  LOCATE 16, 10: PRINT "MAXIMO EN X = ("; XMAX; ")"; : INPUT T1$
  IF T1$ <> "" THEN XMAX = VAL(T1$)

  LOCATE 17, 10: PRINT "MINIMO EN Y = ("; YMIN; ")"; : INPUT T1$
  IF T1$ <> "" THEN YMIN = VAL(T1$)

  LOCATE 18, 10: PRINT "MAXIMO EN Y = ("; YMAX; ")"; : INPUT T1$
  IF T1$ <> "" THEN YMAX = VAL(T1$)

END SUB

SUB letreros (tipo$, X%)
   
 'Se invoca la subrutina de lectura de letreros para la barra de ayuda

 'Barra
 LOCATE 24, 1: COLOR 15, 2: PRINT STRING$(80, 32);

 SELECT CASE tipo$

  CASE "MENU"
    SELECT CASE X%
	 CASE 6: LOCATE 24, 6: PRINT "ESTABLECE LA RIGIDEZ DE LAS TOLERANCIAS EMPLEADAS DURANTE LA REGRESION"
	 CASE 7: LOCATE 24, 6: PRINT "CREA UN ARCHIVO DE DATOS Y LO ALMACENA EN EL PATRON DE BUSQUEDA ACTUAL"
	 CASE 8: LOCATE 24, 8: PRINT "LEE UN ARCHIVO (PREVIAMENTE CREADO) EN EL PATRON DE BUSQUEDA ACTUAL"
	 CASE 9: LOCATE 24, 12: PRINT "ELECCION DE LOS REGRESORES QUE SE EMPLEARAN EN LA REGRESION"
	 CASE 10: LOCATE 24, 7: PRINT "EJECUCION DE LA REGRESION CON LOS DATOS Y LOS REGRESORES ESTABLECIDOS"
	 CASE 11: LOCATE 24, 15: PRINT "REVISION DE LOS RESULTADOS OBTENIDOS CON LA REGRESION"
	 CASE 12: LOCATE 24, 21: PRINT "CANCELACION DE LOS REGRESORES ESTABLECIDOS"
	 CASE 13: LOCATE 24, 29: PRINT "F I N    D E    S E S I O N"
    END SELECT
   
  CASE "REGRESORES"
    SELECT CASE X%
	 CASE 10: LOCATE 24, 18: PRINT "PERMITE MANTENER LOS ULTIMOS REGRESORES EMPLEADOS"
	 CASE 11: LOCATE 24, 20: PRINT "PERMITE ELEGIR UN REGRESOR DE TIPO POLINOMIAL"
	 CASE 12: LOCATE 24, 18: PRINT "PERMITE MULTIPLICAR ENTRE SI DOS O MAS REGRESORES"
	 CASE 13: LOCATE 24, 20: PRINT "PERMITE OBTENER UN REGRESOR DE TIPO RECIPROCO"
	 CASE 14: LOCATE 24, 18: PRINT "PERMITE DEFINIR UN REGRESOR DE TIPO LOGARITMICO"
	 CASE 15: LOCATE 24, 20: PRINT "PERMITE DEFINIR UNA CONSTANTE COMO REGRESOR"
	 CASE 16: LOCATE 24, 19: PRINT "PERMITE DEFINIR UN REGRESOR CON LA FUNCION SENO"
	 CASE 17: LOCATE 24, 18: PRINT "PERMITE DEFINIR UN REGRESOR CON LA FUNCION COSENO"
	 CASE 18: LOCATE 24, 25: PRINT "CANCELA LOS REGRESORES EXISTENTES"
	 CASE 19: LOCATE 24, 28: PRINT "REGRESAR AL MENU PRINCIPAL"
    END SELECT
 
  CASE "REGRESION"
    SELECT CASE X%
	 CASE 8: LOCATE 24, 16: PRINT "PERMITE VISUALIZAR LAS ESTADISTICAS DE LA REGRESION"
	 CASE 9: LOCATE 24, 21: PRINT "PERMITE VISUALIZAR LOS DATOS DEL AJUSTE"
	 CASE 10: LOCATE 24, 18: PRINT "DESPLIEGA LA GRAFICA DE DATOS VS. REGRESORES"
	 CASE 11: LOCATE 24, 16: PRINT "DESPLIEGA LA GRAFICA DE DATOS VS. CURVA DE AJUSTE"
	 CASE 12: LOCATE 24, 16: PRINT "DESPLIEGA LA GRAFICA DE RESIDUOS VS. ORDENADAS (Y)"
	 CASE 13: LOCATE 24, 18: PRINT "DESPLIEGA LA GRAFICA DE RESIDUOS VS. REGRESORES"
	 CASE 14: LOCATE 24, 20: PRINT "PERMITE VISUALIZAR LA PREDICCION DE VALORES"
	 CASE 15: LOCATE 24, 28: PRINT "REGRESAR AL MENU PRINCIPAL"
    END SELECT
 END SELECT
 COLOR 15, 1

END SUB

SUB marco (reni%, renf%, coli%, colf%, tipo%, ci%, cf%)
	
 'Subprograma que genera un marco
 
   'reni%, renf%-- Rengln inicial y final del recuadro
   'coli%, colf%-- Columna inicial y final del recuadro
   'tipo%       -- 1 para lnea sencilla, 2 para doble y 3 para semi-gruesa
   'ci%, cf%    -- Color inicial (recuadro) y final
 
   'Caractersticas del marco (tipo de lnea)
   SELECT CASE tipo%
		CASE 1
			'lnea sencilla
			esi$ = "": lhs$ = "": lv$ = "": esd$ = "": eii$ = ""
			lhi$ = "": eid$ = ""
		CASE 2
			'lnea doble
			esi$ = "": lhs$ = "": lv$ = "": esd$ = "": eii$ = ""
			lhi$ = "": eid$ = ""
		CASE 3
			'lnea semi-gruesa
			esi$ = "": lhs$ = "": lv$ = "": esd$ = "": eii$ = ""
			lhi$ = "": eid$ = ""
   END SELECT
 
   'Se despliega el recuadro
   COLOR ci%
	LOCATE reni%, coli%: PRINT esi$
	LOCATE reni%, colf%: PRINT esd$
	LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
	FOR I% = reni% + 1 TO renf%
	    LOCATE I%, coli%: PRINT lv$
	    LOCATE I%, colf%: PRINT lv$
	NEXT I%
	LOCATE renf%, coli%: PRINT eii$
	LOCATE renf%, colf%: PRINT eid$
	LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
   COLOR cf%

END SUB

SUB menupantalla (FILE$, C1%, COLUMNX%, STATUS$())
 
  'Configuracin de pantalla de men
  LOCATE 4, 10: PRINT " M E N U  P R I N C I P A L ͻ"
  LOCATE 5, 10: PRINT "                              "
  LOCATE 6, 10: PRINT "    - NIVEL-CONFIANZA         "
  LOCATE 7, 10: PRINT "    - CREAR ARCHIVO-DATOS     "
  LOCATE 8, 10: PRINT "    - REVISAR ARCHIVO-DATOS   "
  LOCATE 9, 10: PRINT "    - SELECCIONAR REGRESORES  "
 LOCATE 10, 10: PRINT "    - EJECUTAR REGRESION      "
 LOCATE 11, 10: PRINT "    - REVISAR RESULTADOS      "
 LOCATE 12, 10: PRINT "    - BORRAR REGRESORES       "
 LOCATE 13, 10: PRINT "    - SALIR                   "
 LOCATE 14, 10: PRINT "                              "
 LOCATE 15, 10: PRINT "ͼ"

 'Configuracin de pantalla archivos
 IF FILE$ = "" THEN FILE$ = "N I N G U N O"
 LOCATE 17, 10: PRINT "ͻ"
 LOCATE 18, 10: PRINT " ARCHIVO:  "; : COLOR 14, 1: PRINT FILE$; : COLOR 15, 1
						    PRINT TAB(37); ""
 LOCATE 19, 10: PRINT "ͼ"

 'Se reinicializa la variable FILE$
 IF FILE$ = "N I N G U N O" THEN FILE$ = ""

 'Configuracin de datos para regresin
	  LOCATE 5, 50: PRINT "  DATOS PARA REGRESION  ͻ"
 LOCATE 6, 50: PRINT USING "  NIVEL CONFIANZA = ### % "; C1%
 LOCATE 7, 50:       PRINT "                          "
 LOCATE 8, 50:       PRINT "  REGRESORES ACTUALES:    "
 IF COLUMNX% = 0 THEN
	  LOCATE 9, 50: PRINT "       N I N G U N O      "
	 LOCATE 10, 50: PRINT "ͼ"
 ELSE
	 FOR I = 1 TO COLUMNX% - 1:
		LOCATE 8 + I, 50: PRINT "                          "
		LOCATE 8 + I, 60: PRINT STATUS$(I);
	 NEXT
	 LOCATE 8 + I, 50: PRINT "                          "
	 LOCATE 9 + I, 50: PRINT "ͼ"
 END IF

 COLOR 14, 1: LOCATE 11 + I, 60: PRINT "F1-AYUDA": COLOR 15, 1
 
 'Despliegue de barra de ayuda
 LOCATE 24, 1: COLOR 15, 2: PRINT STRING$(80, 32);
 LOCATE 24, 24: PRINT "USE LAS TECLAS < ,  > PARA MOVERSE": COLOR 15, 1

END SUB

SUB opcion1 (DN$, UP$, C1%, TIND%)
 
 'Subrutina para elegir el nivel de confianza
  
NC: COLOR 1, 15
    LOCATE 13, 40: PRINT "  NIVEL DE CONFIANZA ͻ"
    LOCATE 14, 40: PRINT "                         "
    LOCATE 15, 40: PRINT "          - 99%          "
    LOCATE 16, 40: PRINT "          - 98%          "
    LOCATE 17, 40: PRINT "          - 95%          "
    LOCATE 18, 40: PRINT "          - 90%          "
    LOCATE 19, 40: PRINT "          - 80%          "
    LOCATE 20, 40: PRINT "          - 50%          "
    LOCATE 21, 40: PRINT "          - SALIR        "
    LOCATE 22, 40: PRINT "                         "
    LOCATE 23, 40: PRINT "ͼ"

  'Desplazamiento del cursor
    X% = 15:  LOCATE X%, 51, 1, 0, 7
NC1: ANS$ = INKEY$: IF ANS$ = "" THEN GOTO NC1
    IF ANS$ = DN$ THEN IF X% < 21 THEN X% = X% + 1 ELSE X% = 15
    IF ANS$ = UP$ THEN IF X% > 15 THEN X% = X% - 1 ELSE X% = 21
  'Se oprime <enter>
    LOCATE X%, 51: IF ANS$ <> CHR$(13) THEN GOTO NC1
    FLAG% = CSRLIN - 14
 
  'Eleccin del nivel
    SELECT CASE FLAG%
	  CASE 1: C1% = 99: TIND% = 6
	  CASE 2: C1% = 98: TIND% = 5
	  CASE 3: C1% = 95: TIND% = 4
	  CASE 4: C1% = 90: TIND% = 3
	  CASE 5: C1% = 80: TIND% = 2
	  CASE 6: C1% = 50: TIND% = 1
    END SELECT

END SUB

SUB opcion23 (FLAG1%, FILE$, NEWFILE%, X#(), Y#(), ROWX%, ROW%, COLUMNX%)

 'Subrutina para opciones 2 y 3 del men principal
    
    LOCATE , , 0
ED: IF FLAG1% = 3 THEN NEWFILE% = 1 ELSE NEWFILE% = 0
    IF NEWFILE% = 1 THEN CLS : SHELL ("DIR/W *.REG")
    CONTAD = 0
    'Barra
U:  LOCATE 22, 11, 0: COLOR 15, 2: PRINT STRING$(80, 32)
    LOCATE 23, 8: INPUT "TECLEE NOMBRE DE ARCHIVO-DATOS (SIN PUNTO NI EXTENSION)"; FILE$:
    COLOR 15, 1
    IF FILE$ = "" THEN BEEP: CONTAD = CONTAD + 1: IF CONTAD = 3 THEN EXIT SUB ELSE GOTO U
    'Archivos de 8 caracteres
    IF LEN(FILE$) > 8 THEN BEEP: GOTO U
    FILE$ = UCASE$(FILE$) + ".REG"
    DX% = FLAG1%
    
    'Se invoca la subrutina de edicin
    CALL editor(FILE$, NEWFILE%, X#(), Y#(), ROWX%, ROW%, COLUMNX%)
   
    FOR I = 1 TO ROWX%
	   Y#(I) = X#(I, 1)
    NEXT
    FOR I = 1 TO ROW%
	   X#(I, 1) = 1!
    NEXT

END SUB

SUB opcion4 (FILE$, DN$, UP$, X#(), COLUMNX%, ROW%, P$(), STATUS$(), MX%, MY%)

 'Subrutina para seleccin de regresores

  'Si no se seleccion previamente algn archivo se regresa al men principal
  IF FILE$ = "" THEN BEEP: EXIT SUB
  CLS
  REDIM T#(200, 9): LOCATE , , 0: DONE% = 0: SFLAG% = 0: MX% = 5
  FOR J = 2 TO COLUMNX%
	 FOR I = 1 TO ROW%
		T#(I, J - 1) = X#(I, J)
  NEXT I, J

  FOR I = 1 TO COLUMNX%
	 P$(I) = STATUS$(I):
  NEXT
   
  COUNT% = 1: CLS : LOCATE 5, 11
  COLOR 14, 1: PRINT " SELECCION DEL COEF. :": COLOR 30, 1
  LOCATE 5, 33: PRINT COUNT%: COLOR 15, 1, 0: PRINT
  PRINT TAB(3); " SELECCION  VARS.  INDEPS. ͻ"
  PRINT TAB(3); "                                     "
  PRINT TAB(3); "                                     "
  PRINT TAB(3); "        - REGRESOR SIN CAMBIO        "
  PRINT TAB(3); "        - POLINOMIAL                 "
  PRINT TAB(3); "        - MULT. DE REGRESORES        "
  PRINT TAB(3); "        - RECIPROCO                  "
  PRINT TAB(3); "        - LOG. NATURAL               "
  PRINT TAB(3); "        - CONSTANTE                  "
  PRINT TAB(3); "        - SENO                       "
  PRINT TAB(3); "        - COSENO                     "
  PRINT TAB(3); "        - CANCELAR                   "
  PRINT TAB(3); "        - SALIR                      "
  PRINT TAB(3); "                                     "
  PRINT TAB(3); "ͼ"
					   
  'Despliegue de barra de ayuda
  LOCATE 24, 1: COLOR 15, 2: PRINT STRING$(80, 32);
  LOCATE 24, 24: PRINT "USE LAS TECLAS < ,  > PARA MOVERSE": COLOR 15, 1
  COLOR 14, 1: LOCATE 11 + I, 60: PRINT "F1-AYUDA": COLOR 15, 1
 
  LOCATE 3, 59, 1: PRINT "ECUACION": LOCATE 4, 59: PRINT ""

  'Desplazamiento del cursor              
  X% = 10: LOCATE X%, 12, 1, 0, 7
PS: ANS$ = INKEY$: IF ANS$ = "" THEN GOTO PS
  IF ANS$ = CHR$(0) + CHR$(59) THEN CALL ayuda("REGRESORES"): EXIT SUB
  IF ANS$ = DN$ THEN IF X% < 19 THEN X% = X% + 1 ELSE X% = 10
  IF ANS$ = UP$ THEN IF X% > 10 THEN X% = X% - 1 ELSE X% = 19
  
  'Se invoca la subrutina de lectura de letreros para la barra de ayuda
  CALL letreros("REGRESORES", X%)
 
  'Eleccin
  LOCATE X%, 12: IF ANS$ <> CHR$(13) THEN GOTO PS
  FLAG% = CSRLIN - 9
  ON FLAG% GOSUB Sc, Pol, Mul, Rec, Ln, K, Sen, Cose, Canc, Sal
  IF FLAG% = 10 THEN DX% = 5: EXIT SUB
  LOCATE 22, 1: PRINT STRING$(40, 32);
  COUNT% = COUNT% + 1
 
  'Nmero mximo de regresores=10
  IF COUNT% > 10 THEN BEEP: BEEP: BEEP: GOTO Sal
  LOCATE 5, 33: COLOR 30, 1, 0: PRINT COUNT%
  COLOR 15, 1, 0: LOCATE X%, 12, 1: GOTO PS

'---------------------------------------------------  REGRESOR SIN CAMBIO
Sc:  LOCATE 22, 1: INPUT " CUAL REGRESOR "; CO%
	IF CO% = 0 THEN BEEP: GOTO Sc
	IF CO% + 1 > COLUMNX% THEN BEEP: BEEP: BEEP: GOTO Sc
	T1% = COUNT% + 48: COUNT$ = CHR$(T1%)
	T2% = CO% + 48: CO$ = CHR$(T2%)
	STATUS$(COUNT%) = "C" + COUNT$ + "= X" + CO$
	LOCATE MX%, MY%:  PRINT STATUS$(COUNT%)
	MX% = MX% + 1: SFLAG% = 1
	FOR I = 1 TO ROW%
	    X#(I, COUNT% + 1) = T#(I, CO%)
	NEXT
	RETURN

'---------------------------------------------------  POLINOMIAL
Pol: LOCATE 22, 1: INPUT " CUAL X "; CO%
	IF CO% = 0 THEN BEEP: GOTO Pol
	IF CO% + 1 > COLUMNX% THEN BEEP: BEEP: BEEP: GOTO Pol
	LOCATE 22, 1: INPUT " POTENCIA"; POWER$
	T1% = COUNT% + 48: COUNT$ = CHR$(T1%): POWER% = VAL(POWER$)
	T2% = CO% + 48: CO$ = CHR$(T2%)
	STATUS$(COUNT%) = "C" + COUNT$ + "= X" + CO$ + "^" + POWER$
	LOCATE MX%, MY%: PRINT STATUS$(COUNT%)
	MX% = MX% + 1: SFLAG% = 1
	FOR I = 1 TO ROW%
	    TIC# = T#(I, CO%): TEMP# = 1
	    FOR J = 1 TO POWER%
		   TEMP# = TEMP# * TIC#
	    NEXT J
	    X#(I, COUNT% + 1) = TEMP#
	NEXT I
	RETURN

'---------------------------------------------------  MULTIPLICACION
Mul: LOCATE 22, 1: INPUT " REGRESORES (SEP. POR COMAS): "; CO%, C1%
	IF CO% = 0 OR C1% = 0 THEN BEEP:  GOTO Mul
	IF (CO% + 1) > COLUMNX% OR (C1% + 1) > COLUMNX% THEN BEEP: BEEP: BEEP:  RETURN
	T1% = COUNT% + 48: COUNT$ = CHR$(T1%): T2% = CO% + 48: CO$ = CHR$(T2%)
	T3% = C1% + 48: C1$ = CHR$(T3%)
	STATUS$(COUNT%) = "C" + COUNT$ + "= X" + CO$ + "* X" + C1$
	LOCATE MX%, MY%: PRINT STATUS$(COUNT%)
	MX% = MX% + 1: SFLAG% = 1
	FOR I = 1 TO ROW%
	    X#(I, COUNT% + 1) = T#(1, CO%) * T#(I, C1%):
	NEXT
	RETURN

'---------------------------------------------------  RECIPROCO
Rec: LOCATE 22, 1: INPUT " RECIPROCO DE X "; CO%
	IF CO% = 0 THEN
	   BEEP: GOTO Rec
	END IF
	IF CO% + 1 > COLUMNX% THEN BEEP: BEEP: BEEP: GOTO Rec
	T1% = COUNT% + 48: COUNT$ = CHR$(T1%)
	T2% = CO% + 48: CO$ = CHR$(T2%)
	STATUS$(COUNT%) = "C" + COUNT$ + "= 1/X" + CO$
	LOCATE MX%, MY%: PRINT STATUS$(COUNT%)
	MX% = MX% + 1: SFLAG% = 1
	FOR I = 1 TO ROW%
	   X#(I, COUNT% + 1) = 1 / T#(I, CO%)
	NEXT
	RETURN

'---------------------------------------------------  LOG. NAT.(X)
Ln: LOCATE 22, 1: INPUT " LOG NATURAL DE X"; CO%
    IF CO% = 0 THEN BEEP: GOTO Ln
    IF CO% + 1 > COLUMNX% THEN BEEP: BEEP: BEEP: GOTO Ln
    T1% = COUNT% + 48: COUNT$ = CHR$(T1%)
    T2% = CO% + 48: CO$ = CHR$(T2%)
    STATUS$(COUNT%) = "C" + COUNT$ + "= LN(X" + CO$ + ")"
    LOCATE MX%, MY%: PRINT STATUS$(COUNT%)
    MX% = MX% + 1: SFLAG% = 1
    FOR I = 1 TO ROW%
	  X#(I, COUNT% + 1) = LOG(T#(I, CO%))
    NEXT
    RETURN

'---------------------------------------------------  CONSTANTE
K: LOCATE 22, 1: INPUT " CONSTANTE "; CO%
   IF CO% = 0 THEN BEEP: GOTO K
   T1% = COUNT% + 48: COUNT$ = CHR$(T1%)
   T2% = CO% + 48: CO$ = CHR$(T2%)
   STATUS$(COUNT%) = "C" + COUNT$ + "= " + CO$
   LOCATE MX%, MY%: PRINT STATUS$(COUNT%): MX% = MX% + 1: SFLAG% = 1
   FOR I = 1 TO ROW%
	  X#(I, COUNT% + 1) = CO%
   NEXT
   RETURN

'---------------------------------------------------  SEN(X)
Sen: LOCATE 22, 1: INPUT " SENO DE X"; CO%
	IF CO% = 0 THEN BEEP: GOTO Sen
	IF CO% + 1 > COLUMNX% THEN BEEP: BEEP: BEEP: GOTO Sen
	T1% = COUNT% + 48: COUNT$ = CHR$(T1%)
	T2% = CO% + 48: CO$ = CHR$(T2%)
	STATUS$(COUNT%) = "C" + COUNT$ + "= SIN(X" + CO$ + ")"
	LOCATE MX%, MY%: PRINT STATUS$(COUNT%)
	MX% = MX% + 1: SFLAG% = 1
	FOR I = 1 TO ROW%
	    TEMP = T#(I, CO%) * 3.141593 / 180
	    X#(I, COUNT% + 1) = SIN(TEMP)
	NEXT
	RETURN

'---------------------------------------------------  COS(X)
Cose: LOCATE 22, 1: INPUT "COSENO DE X"; CO%
	 IF CO% = 0 THEN BEEP: GOTO Cose
	 IF CO% + 1 > COLUMNX% THEN BEEP: BEEP: BEEP: GOTO Cose
	 T1% = COUNT% + 48: COUNT$ = CHR$(T1%)
	 T2% = CO% + 48: CO$ = CHR$(T2%)
	 STATUS$(COUNT%) = "C" + COUNT$ + "= COS(X" + CO$ + ")"
	 LOCATE MX%, MY%: PRINT STATUS$(COUNT%)
	 MX% = MX% + 1: SFLAG% = 1
	 FOR I = 1 TO ROW%
		TEMP = T#(I, CO%) * 3.141593 / 180
		X#(I, COUNT% + 1) = COS(TEMP)
	 NEXT
	 RETURN

'---------------------------------------------------  CANCELAR
Canc: FOR I = 1 TO COLUMNX%
		STATUS$(I) = P$(I)
	 NEXT
	 MX% = 5: FOR I = 1 TO COUNT%
	 LOCATE MX%, MY%: PRINT STRING$(15, 32); : MX% = MX% + 1: NEXT I
	 FOR J = 2 TO COLUMNX%
		FOR I = 1 TO ROW%
		    X#(I, J) = T#(I, J - 1)
	 NEXT I, J
	 MX% = 5: X% = 10: COUNT% = 0: SFLAG% = 0
	 RETURN

'--------------------------------  SALIDA DEL MENU SELECCION DE REGRESORES
Sal: IF SFLAG% = 1 THEN COLUMNX% = COUNT%
	ERASE T#
	RETURN

END SUB

